package openmind;

import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import touchgraph.graphlayout.*;

public class AAA extends JPanel implements ActionListener{
	JLabel lProfession, lReligion, lRace, lAge, lStatus, lMode;
	JComboBox cbProfession, cbReligion, cbRace, cbMode;
	JButton bCreate, bSearch, bSortAmazon, bDrawProfile, bDrawAmazon, bDrawBoth, bClearVisual, bClearAll;
	JTextField tfAge, tfRecommend;
	JTextArea taProfile, taAmazon;
	JScrollPane spProfile, spAmazon;
	JPanel pProfileInput, pProfileControl, pProfileOutput, pOutput, pCreate, pAmazon, pBrowse, pBrowseControl, pTop, pSearch, pClear;
	Connection con;
	String strMode, strProfession, strReligion, strRace,  strAge;
	FileWriter fwProfileFile;
	StringReader srProfileInfo;
	FileIO fileIO = new FileIO();
	boolean bFlag = false;
	Vector vProf, vRel, vAge, vRace;
	Amazon aAmazon;
	Profile pProfile;
	AAANet aaaNet;
	VisualNet pVisual;
	Vector vAmazonQueries;
	Vector vAmazonResults;
	Vector vProfileNodes;
	Thread tOutput;
	Hashtable sortedResults;
	int iAmazon, iProfile, iVisual;
	
	public AAA(){
		aaaNet = new AAANet();
		aAmazon = new Amazon();
		pVisual = new VisualNet();
		
		taProfile = new JTextArea(25, 50);
		taProfile.setLineWrap(true);
		taProfile.setWrapStyleWord(true);
		taAmazon = new JTextArea(25, 50);
		taAmazon.setLineWrap(true);
		taAmazon.setWrapStyleWord(true);

		pProfileInput = new JPanel();
		pProfileControl = new JPanel();
		pProfileOutput = new JPanel();

		
		pOutput = new JPanel();
		pCreate = new JPanel();
		pAmazon = new JPanel();
		pBrowse = new JPanel();
		pBrowseControl = new JPanel();
		pTop = new JPanel();
		pSearch = new JPanel();
		pClear = new JPanel();
		
		spProfile = new JScrollPane(taProfile);
		spProfile.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		spProfile.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		spAmazon = new JScrollPane(taAmazon);
		spAmazon.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		spAmazon.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		
		lStatus = new JLabel();
		sortedResults = new Hashtable();
		

		pProfileInput.setBackground(Color.white);
		pOutput.setBackground(Color.white);
		pCreate.setBackground(Color.white);
		pAmazon.setBackground(Color.white);
		pBrowse.setBackground(Color.white);
		pTop.setBackground(Color.white);
		pSearch.setBackground(Color.white);
		pProfileControl.setBackground(Color.white);
		pProfileOutput.setBackground(Color.white);
		pBrowseControl.setBackground(Color.white);
		pClear.setBackground(Color.white);
		
		bCreate = new JButton("Generate profile");
		bSearch = new JButton("Search Amazon");
		bSortAmazon = new JButton("Sort results");
		bDrawProfile = new JButton("Draw profile");
		bDrawAmazon = new JButton("Draw Amazon results");
		bDrawBoth = new JButton("<--------------Connect-------------->");
		bClearVisual = new JButton("Clear visuals");
		bClearAll = new JButton("Restart");
		
		tfAge = new JTextField();
		
		lProfession = new JLabel("Profession: ", SwingConstants.RIGHT);
		lReligion = new JLabel("Religion: ", SwingConstants.RIGHT);
		lRace = new JLabel("Ethnicity: ", SwingConstants.RIGHT);
		lAge = new JLabel("Age: ", SwingConstants.RIGHT);
		lMode = new JLabel("Mode: ", SwingConstants.RIGHT);
		lStatus = new JLabel(" ");
		
		String[] sProfession = {"Engineer", 
					"Doctor", 
					"Athelete",
					"Artist", 
					"Banker",
					"Lawyer",
					"Researcher",
					"Unemployed"};
		String[] sReligion = { "Atheist",
				       "Buddhism",
				       "Catholic",
				       "Muslim",
				       "Protestant"};
		String[] sRace = {"African American",
					"American",
					"Asian",
				    "British",
				    "Indian",
				  	};
				  
		String[] sMode = {"Books","Music","DVD", "Apparel", "Baby", "Classical", "Electronics", "Garden", "Kitchen", "Magazines", "PC-Hardware", "Photo", "Software", "Toys", "Universal", "VHS", "Videogames"};
		
		cbMode = new JComboBox(sMode);
		cbProfession = new JComboBox(sProfession);
		cbReligion = new JComboBox(sReligion);
		cbRace = new JComboBox(sRace);

		con = new Connection("http://commonsense.media.mit.edu/cgi-bin/get.cgi?");

		bCreate.addActionListener(this);
		bSearch.addActionListener(this);
		bSortAmazon.addActionListener(this);
		bDrawProfile.addActionListener(this);
		bDrawAmazon.addActionListener(this);
		bDrawBoth.addActionListener(this);
		bClearVisual.addActionListener(this);
		bClearAll.addActionListener(this);
		
		pProfileInput.setLayout(new GridLayout(2, 4, 1, 1));
		
		pProfileInput.add(lProfession);
		pProfileInput.add(cbProfession);
		
		pProfileInput.add(lReligion);
		pProfileInput.add(cbReligion);

		pProfileInput.add(lRace);
		pProfileInput.add(cbRace);
		
		pProfileInput.add(lAge);
		pProfileInput.add(tfAge);
		
		pProfileInput.setBorder(BorderFactory.createCompoundBorder(
									BorderFactory.createTitledBorder("Personal Facts"),
									BorderFactory.createEmptyBorder(5,5,5,5)));
		
		
		pProfileOutput.setLayout(new BorderLayout());
		pProfileOutput.add(bCreate, BorderLayout.NORTH);
		pProfileOutput.add(spProfile, BorderLayout.CENTER);
		
		pSearch.setLayout(new GridLayout(1, 3, 1, 1));
		
		pSearch.add(cbMode);
		pSearch.add(bSearch);
		pSearch.add(bSortAmazon);
		
		pBrowseControl.setLayout(new GridLayout(1, 3, 1, 1));
		pBrowseControl.add(bDrawProfile);
		pBrowseControl.add(bDrawBoth);
		pBrowseControl.add(bDrawAmazon);

		pClear.setLayout(new GridLayout(1, 2, 1, 1));
		pClear.add(bClearVisual);
		pClear.add(bClearAll);

		pCreate.setLayout(new BorderLayout());
		pAmazon.setLayout(new BorderLayout());
		pBrowse.setLayout(new BorderLayout());
		
		pCreate.add(pProfileInput, BorderLayout.NORTH);
		pCreate.add(pProfileOutput, BorderLayout.CENTER);
		pCreate.setBorder(BorderFactory.createCompoundBorder(
											BorderFactory.createTitledBorder("First create your own profile..."),
											BorderFactory.createEmptyBorder(5,5,5,5)));

		pAmazon.add(pSearch, BorderLayout.NORTH);
		pAmazon.add(spAmazon, BorderLayout.CENTER);
		pAmazon.setBorder(BorderFactory.createCompoundBorder(
											BorderFactory.createTitledBorder("then search Amazon..."),
											BorderFactory.createEmptyBorder(5,5,5,5)));
		
		pBrowse.add(pBrowseControl, BorderLayout.NORTH);
		pBrowse.add(pVisual, BorderLayout.CENTER);
		pBrowse.add(pClear, BorderLayout.SOUTH);
		pBrowse.setBorder(BorderFactory.createCompoundBorder(
											BorderFactory.createTitledBorder("and then see it in action"),
											BorderFactory.createEmptyBorder(5,5,5,5)));

		pTop.setLayout(new GridLayout(1, 2, 1, 1));
		pTop.setPreferredSize(new Dimension(800, 350));
		pTop.add(pCreate);
		pTop.add(pAmazon);
		
		setLayout(new BorderLayout());
		setPreferredSize(new Dimension(100, 100));
		add(pTop, BorderLayout.NORTH);
		add(pBrowse, BorderLayout.CENTER);
		add(lStatus, BorderLayout.SOUTH);
	}

	public void actionPerformed(ActionEvent ae){
		strMode = (String) cbMode.getSelectedItem();
		strProfession = (String) cbProfession.getSelectedItem();
		strReligion = (String) cbReligion.getSelectedItem();
		strRace = (String) cbRace.getSelectedItem();
		strAge = tfAge.getText();
		if(strAge == null || strAge.equals("")){
			strAge = "22";
		}
		Integer age = new Integer(strAge);
		int iAge = age.intValue();
		if(iAge < 10){
			strAge = "Child";
		}
		else if(iAge < 20){
			strAge = "Teenager";
		}
		else if(iAge < 30){
			strAge = "Young";
		}
		else if(iAge < 50){
			strAge = "Adult";
		}
		else if(iAge < 100){
			strAge = "Elderly";
		}
		else {
			strAge = "Adult";
		}
		
		if(ae.getSource() == bCreate){
			lStatus.setText("Generating profile");
			pProfile = aaaNet.createProfile(strProfession,strReligion,strRace,strAge);
			taProfile.setText(pProfile.toString());
			lStatus.setText("Profile created");
		}
		
		if(ae.getSource() == bSearch){
			if(pProfile==null) lStatus.setText("You need to create a profile first");
			else{
				if(tOutput!=null) tOutput.stop();
				lStatus.setText("Querying Amazon");
				taAmazon.setText("");
				iAmazon = 0;
				vAmazonResults = new Vector();
				vAmazonQueries = generateQueries();
				tOutput = new Thread(){
					public void run(){
						for(int i=0;i<vAmazonQueries.size();i++){
							lStatus.setText("Search completed: "+i*100/vAmazonQueries.size()+"%");
							Vector amazonResults = aAmazon.searchAmazon((String) vAmazonQueries.get(i),strMode.toLowerCase());
							for (int j=0;j<amazonResults.size();j++){
								iAmazon++;
								AAANode anNode = (AAANode) amazonResults.get(j);
								anNode = score(anNode);
								taAmazon.append(anNode.toString() + "\n");
								vAmazonResults.add(anNode);
										
							}
						}
						lStatus.setText("Amazon search completed. Found "+iAmazon+" "+strMode);
					}
				}
				;tOutput.start();
			}
		}
		
		if(ae.getSource() == bSortAmazon){
			if(vAmazonResults==null||vAmazonResults.size()<1) lStatus.setText("Nothing to sort");
			else{
				taAmazon.setText("");
				sortAmazonResults();
				for (int i=0;i<vAmazonResults.size();i++){
					AAANode anNode = (AAANode) vAmazonResults.get(i);
					taAmazon.append(anNode.toString() + "\n");
				}
				lStatus.setText("Sorted");		
			}
		}
		
		if(ae.getSource() == bDrawProfile){
			if(pProfile==null) lStatus.setText("You need to create a profile first");
			else{
				lStatus.setText("Drawing profile");
				pProfile.visualise(pVisual);
			}
		}
		
		if(ae.getSource() == bDrawAmazon){
			if(vAmazonResults==null||vAmazonResults.size()<1) lStatus.setText("Search Amazon first");
			else{
				lStatus.setText("Drawing Amazon results");
				Vector browseLists = new Vector();
				pVisual.addColouredNode("AMAZON", strMode, Color.GREEN, Color.BLUE, Color.GRAY);
				for(int i=0;i<vAmazonResults.size();i++){
					AAANode anNode = (AAANode) vAmazonResults.get(i);
					if(qualify(anNode)){
						if(anNode.edges.size()>0){
							String browselist = ((Edge) anNode.edges.get(0)).Pred;
							pVisual.addColouredNode(browselist, anNode.name, Color.RED, Color.BLACK, Color.GRAY);
							if(!browseLists.contains(browselist)){
								pVisual.addColouredNode(strMode, browselist, Color.BLUE, Color.RED, Color.GRAY);
								browseLists.add(browselist);		
							}

						}
						else {
							String temp = "Uncategorised "+ strMode;
							pVisual.addColouredNode(temp, anNode.name, Color.RED, Color.BLACK, Color.GRAY);
							if(!browseLists.contains(temp)){
								pVisual.addColouredNode(strMode, temp, Color.BLUE, Color.RED, Color.GRAY);
								browseLists.add(temp);
							}
						}
					}
				}
			}
		}
		
		if(ae.getSource() == bDrawBoth){
			if(pProfile==null) lStatus.setText("You need to create a profile first");
			else{
				lStatus.setText("Drawing profile");
				pProfile.visualise(pVisual);
			}
			if(vAmazonResults==null||vAmazonResults.size()<1) lStatus.setText("Search Amazon first");
			else{
				tOutput = new Thread(){
					public void run(){
						lStatus.setText("Drawing Amazon results");
						for(int i=0;i<vAmazonResults.size();i++){
							AAANode anNode = (AAANode) vAmazonResults.get(i);
							if(qualify(anNode)){
								if(anNode.edges.size()>0){
									String browselist = ((Edge) anNode.edges.get(0)).Pred;
									pVisual.addColouredNode(anNode.name.toLowerCase(), browselist.toLowerCase(), Color.BLACK, Color.RED, Color.GRAY);
									pVisual.addColouredNode(anNode.target.toLowerCase(), browselist.toLowerCase(), Color.RED, Color.GRAY);

								}
								else pVisual.addColouredNode(anNode.target.toLowerCase(), anNode.name.toLowerCase(), Color.RED, Color.GRAY);
								}
							}
						//matching Amazon results with profile
						/*
						for(int j=0;j<amazonResults.size();j++){
							AAANode anNode = (AAANode) amazonResults.get(j);
							for(int k=0;k<vProfileNodes.size();k++){
								String concept = ((String) vProfileNodes.get(k)).toLowerCase();
								
								if(anNode.name.toLowerCase().indexOf(concept)!=-1){
									lStatus.setText("Adding "+anNode.name+"to search space");
									//pVisual.addColouredNode(concept, anNode.name.toLowerCase(), Color.BLACK, Color.GRAY);
									
									//new stuff for counting
									String next = anNode.name.toLowerCase();
									if(sortedResults.containsKey(next)){
										Integer iInt = (Integer) sortedResults.get(next);
										int x = iInt.intValue();
										x++;
										iInt = new Integer(x);
										sortedResults.remove(next);
										sortedResults.put(next, iInt);
									}
									else {
										sortedResults.put(next, new Integer(1));
									}
								}
								
								for(int l=0;l<anNode.edges.size();l++){
									String browselist = ((Edge) anNode.edges.get(l)).Pred;
									if(browselist.toLowerCase().indexOf(concept)!=-1){
										lStatus.setText("Adding "+anNode.name+"to search space");
										//pVisual.addColouredNode(anNode.name.toLowerCase(), browselist.toLowerCase(), Color.BLACK, Color.RED, Color.GRAY);
										//pVisual.addColouredNode(concept.toLowerCase(), browselist.toLowerCase(), Color.RED, Color.GRAY);
										
										
										//new stuff for counting
										String next = anNode.name.toLowerCase();
										if(sortedResults.containsKey(next)){
											Integer iInt = (Integer) sortedResults.get(next);
											int x = iInt.intValue();
											x++;
											iInt = new Integer(x);
											sortedResults.remove(next);
											sortedResults.put(next, iInt);
										}
										else {
											sortedResults.put(next, new Integer(1));
										}
										
										
										
									}
								}
							}
						}					
					}
					//cycle through and draw results
					Vector results = FileIO.sort(sortedResults, 20);
					for(int j=0;j<results.size();j++){
						String nodeName = (String) results.get(j);
						System.out.println("amazon node: "+nodeName);
						for(int i=0;i<vProfileNodes.size();i++){
							String concept = (String) vProfileNodes.get(i);

							if(nodeName.indexOf(concept)!=-1){
								pVisual.addColouredNode(concept, nodeName, Color.BLACK, Color.RED, Color.GRAY);
							}
						}
					}
					
					*/
					
					lStatus.setText("Done");
					}
				}
			;tOutput.start();
			}
		}
		
		if(ae.getSource() == bClearVisual){
			pVisual.clearAll();
		}
		
		if(ae.getSource() == bClearAll){
			pProfile = null;
			pVisual.clearAll();
			vAmazonResults = new Vector();
			taProfile.setText("");
			taAmazon.setText("");
			lStatus.setText("Cleared");
			tOutput.stop();
		}
	}
	
	private Vector generateQueries(){
		lStatus.setText("Generating Amazon query");
		Vector queries = new Vector();
		Vector test = new Vector();
		//adding attribues
		//test.add(strAge);
		//test.add(strRace);
		//test.add(strProfession);
		//test.add(strReligion);
		//adding AAANet inference results
		//test.addAll(pProfile.getInstanceNodes());
		
		vProfileNodes = (Vector) pProfile.toInstanceStringVector();
		
		queries.addAll(pProfile.toInstanceStringVector());
		
		/*
		
		//adding combinations of attributes
		queries.add(strProfession+"%20"+strReligion);
		queries.add(strProfession+"%20"+strAge);
		queries.add(strProfession+"%20"+strRace);
		queries.add(strProfession+"%20"+strReligion+"%20"+strAge);
		queries.add(strProfession+"%20"+strReligion+"%20"+strRace);
		queries.add(strProfession+"%20"+strAge+"%20"+strRace);
		queries.add(strProfession+"%20"+strReligion+"%20"+strAge+"%20"+strRace);
		queries.add(strReligion+"%20"+strAge);
		queries.add(strReligion+"%20"+strRace);
		queries.add(strReligion+ "%20"+strAge+"%20"+strRace);
		queries.add(strAge+"%20"+strRace);
		//adding synonyms
		queries.addAll(fileIO.readFileToVector("attributes/profession/"+strProfession.toLowerCase()+".txt"));
		queries.addAll(fileIO.readFileToVector("attributes/religion/"+strReligion.toLowerCase()+".txt"));
		queries.addAll(fileIO.readFileToVector("attributes/race/"+strRace.toLowerCase()+".txt"));
		queries.addAll(fileIO.readFileToVector("attributes/age/"+strAge.toLowerCase()+".txt"));
		*/
		
		return queries;
	}
	
	private AAANode score(AAANode anNode){
		
		Vector instanceNodes = pProfile.getInstanceNodes();
		Vector genreNodes = pProfile.getGenreNodes();
		Vector relatedNodes = pProfile.getRelatedNodes();
		boolean matchYet = false;
		double maxWeight = 0;
		String target = "unrelated";
		
		//match name to instances
		for(int i=0;i<instanceNodes.size()&&!matchYet;i++){
			AAANode instance = ((AAANode) instanceNodes.get(i));
			if(anNode.name.toLowerCase().indexOf(instance.name.toLowerCase())!=-1){
				
				anNode.setWeight(anNode.weight+instance.weight);
				if(anNode.weight>1) anNode.setWeight(1);
				//record weight
				if(maxWeight<instance.weight) {
					maxWeight = instance.weight;
					target = instance.name;
				}
			}
		}
		
		//match name to related
		for(int i=0;i<relatedNodes.size()&&!matchYet;i++){
			AAANode related = ((AAANode) relatedNodes.get(i));
			if(anNode.name.toLowerCase().indexOf(related.name.toLowerCase())!=-1){

				anNode.setWeight(anNode.weight+related.weight-0.2);
				if(anNode.weight>1) anNode.setWeight(1);
				if(maxWeight<related.weight) {
					maxWeight = related.weight;
					target = related.name;
				}
			}
		}
		
		//match browselist to genre
		for(int i=0;i<anNode.edges.size();i++){
			String browselist = ((Edge) anNode.edges.get(i)).Pred.toLowerCase();
			for(int j=0;j<genreNodes.size();j++){
				AAANode genre = (AAANode) genreNodes.get(j);
				if(browselist.indexOf(genre.name.toLowerCase())!=-1){
					anNode.setWeight(anNode.weight+genre.weight-0.5);
					if(anNode.weight>1) anNode.setWeight(1);
					if(maxWeight<genre.weight) {
						maxWeight = genre.weight;
						target = genre.name;
					}
				}
			}

			//match browselist to related
			for(int j=0;j<relatedNodes.size()&&!matchYet;j++){
				AAANode related = ((AAANode) relatedNodes.get(j));
				if(browselist.indexOf(related.name.toLowerCase())!=-1){

					anNode.setWeight(anNode.weight+related.weight-0.2);
					if(anNode.weight>1) anNode.setWeight(1);
					if(maxWeight<related.weight) {
						maxWeight = related.weight;
						target = related.name;
					}
				}
			}
		}
		
		return anNode.setTarget(target);
	}
	
	private void sortAmazonResults(){
		Pair[] pairs = new Pair[vAmazonResults.size()];
		for(int i=0;i<vAmazonResults.size();i++){
			AAANode node = (AAANode) vAmazonResults.get(i);
			Pair p = new Pair(node);
			pairs[i] = p;
		}
		Arrays.sort(pairs);
		vAmazonResults = new Vector();
		for(int i=0;i<pairs.length;i++){
			vAmazonResults.add(pairs[i].getNode());
		}
	}
	
	private boolean qualify(AAANode node){
		if(strMode.equals("DVD")){
			if(node.weight>0.7) return true;
		}
		if(strMode.equals("Music")){
			if(node.weight>0.7) return true;
		}
		if(strMode.equals("Books")){
			if(node.weight==1) return true;
		}
		else{
			if(node.weight==1) return true;
		}
		return false;
	}
	
	private boolean storeProfileFile(String sFilename, Vector vResults){
		boolean bFlag = false;
		String sFile = "";
		try{
			//Filter and sort results
			for (int i=0;i<vResults.size();i++){
				vResults.set(i, fileIO.sort(fileIO.filterAndCount((String) vResults.get(i))));
			}

			//Add headers
			vResults.set(0, "---Profession---:" + strProfession + "\n" + ((String) vResults.get(0)));
			vResults.set(1, "---Religion---:" + strReligion + "\n" + ((String) vResults.get(1)));
			vResults.set(2, "---Race---:" + strRace + "\n" + ((String) vResults.get(2)));
			vResults.set(3, "---Age---:" + strAge + "\n" + ((String) vResults.get(3)));

			//Combine results
			for (int i=0;i<vResults.size();i++){
				sFile += vResults.get(i);
			}

			//Write the information into a file.
			fwProfileFile = new FileWriter(sFilename);
			srProfileInfo = new StringReader(sFile);
			int c;
			while((c = srProfileInfo.read()) != -1){
				fwProfileFile.write(c);
			}
			srProfileInfo.close();
			fwProfileFile.close();
			bFlag = true;
		}
		catch(Exception e){
			System.out.println(e.toString());
		}
		return bFlag;
	}

}
