package openmind;
//import OMCSNet.*;
import java.util.*;
import java.io.*;
/**
 * Austin created Omcs.java at 2:13:05 PM on Nov 16, 2002
 */
public class AAANet {
	FileIO fileIO = new FileIO();

	Hashtable h1;
	Hashtable h2;
	Hashtable h3;
	Hashtable h4;
	Hashtable h5;
	Hashtable h6;
	Hashtable h7;
	Hashtable h8;

	String filename1 = "semanticnet1.txt";
	String filename2 = "semanticnet2.txt";
	String filename3 = "semanticnet3.txt";
	String filename4 = "semanticnet4.txt";
	String filename5 = "semanticnet5.txt";
	String filename6 = "semanticnet6.txt";
	String filename7 = "semanticnet7.txt";
	String filename8 = "semanticnet8.txt";
	
	
	String stopFile = "stopWords.txt";

	Vector allNodeNames;// holds the names of every node
	Vector stopWords;

	public AAANet(){
		h1 = new Hashtable();
		h2 = new Hashtable();
		h3 = new Hashtable();
		h4 = new Hashtable();
		h5 = new Hashtable();
		h6 = new Hashtable();
		h7 = new Hashtable();
		h8 = new Hashtable();
		
		stopWords = fileIO.readFileToVector(stopFile);
		allNodeNames = new Vector();

		createNet(filename1, h1);
		createNet(filename2, h2);
		createNet(filename3, h3);
		createNet(filename4, h4);
		createNet(filename5, h5);
		createNet(filename6, h6);
		createNet(filename7, h7);
		createNet(filename8, h8);
	}
	

	private AAANode getNode(String nodename){
		if(nodename.compareTo("charm people")<1){
			if(h1.containsKey(nodename)) return (AAANode) h1.get(nodename);
		}
		if(nodename.compareTo("fall in hole")<1){
			if(h2.containsKey(nodename)) return (AAANode) h2.get(nodename);
		}
		if(nodename.compareTo("have kid")<1){
			if(h3.containsKey(nodename)) return (AAANode) h3.get(nodename);
		}
		if(nodename.compareTo("maguro")<1){
			if(h4.containsKey(nodename)) return (AAANode) h4.get(nodename);
		}
		if(nodename.compareTo("picture description : girl")<1){
			if(h5.containsKey(nodename)) return (AAANode) h5.get(nodename);
		}
		if(nodename.compareTo("shop for")<1){
			if(h6.containsKey(nodename)) return (AAANode) h6.get(nodename);
		}
		if(nodename.compareTo("testimony")<1){
			if(h7.containsKey(nodename)) return (AAANode) h7.get(nodename);
		}
		else {
			if(h8.containsKey(nodename)) return (AAANode) h8.get(nodename);
		}
		return new AAANode("");
	}

	private Vector getSimilarNodeNames(String name){
		Vector out = new Vector();
		for (int i=0;i<allNodeNames.size();i++){
			String nodeName = (String) allNodeNames.get(i);
			if(nodeName.indexOf(name)!=-1&&name.length()>3&&!nodeName.equals(name)&&!isStopWord(nodeName)){
				out.add(nodeName);
			}
		}
		return out;
	}
	
	private Vector getSimilarNodes(AAANode node){
		Vector out = new Vector();
		Vector temp = this.getSimilarNodeNames(node.name);
		for (int i=0;i<temp.size();i++){
			String name = (String) temp.get(i);
			out.add(getNode(name).setWeight(0.5).setType("Related"));
		}
		return out;
	}
	
	private Vector getCollocateNodes(AAANode node){
		Vector out = new Vector();
		for (int i=0;i<node.edges.size();i++){
			Edge e = (Edge) node.edges.get(i);
			if(e.Pred.indexOf("hasCollocate")!=-1&&!isStopWord(e.Target)){
				out.add(getNode(e.Target).setWeight(0.25).setType("Vaguely related"));
			}
		}
		return out;
	}
	
	private Vector getBWisANodes(AAANode node){
		Vector out = new Vector();
		for (int i=0;i<node.edges.size();i++){
			Edge e = (Edge) node.edges.get(i);
			if(e.Pred.indexOf("isA")!=-1&&e.Direction.equals("bw")&&!isStopWord(e.Target)){
				out.add(getNode(e.Target).setWeight(0.75).setType("Instance"));
			}
		}
		return out;
	}

	private void createNet(String filename, Hashtable ht){
		StreamTokenizer st = fileIO.readStreamFile(filename);
		try{
			while (st.ttype!=StreamTokenizer.TT_EOF){
				st.nextToken();
				String next = "";
				if(st.ttype==StreamTokenizer.TT_WORD) next = st.sval;
				else next = (new Double(st.nval)).toString();
				if(next.startsWith("NODE:")){
					String nodeName;
					nodeName = next.substring(6);
					AAANode node = new AAANode(nodeName);
					st.nextToken();
					while(!next.equals("*********************************")){
						st.nextToken();
						if(st.ttype==StreamTokenizer.TT_WORD) next = st.sval;
						else next = (new Double(st.nval)).toString();
						String pred = next.substring(6);
						//System.out.println(pred);

						st.nextToken();
						if(st.ttype==StreamTokenizer.TT_WORD) next = st.sval;
						else next = (new Double(st.nval)).toString();
						String tar = next.substring(8);
						//System.out.println(tar);

						st.nextToken();
						if(st.ttype==StreamTokenizer.TT_WORD) next = st.sval;
						else next = (new Double(st.nval)).toString();
						String sen = next.substring(10);
						//System.out.println(sen);

						st.nextToken();
						if(st.ttype==StreamTokenizer.TT_WORD) next = st.sval;
						else next = (new Double(st.nval)).toString();
						String dir = next.substring(11);
						//System.out.println(dir);

						st.nextToken();
						if(st.ttype==StreamTokenizer.TT_WORD) next = st.sval;
						else next = (new Double(st.nval)).toString();
						String weight = next.substring(8);
						//System.out.println(weight);

						st.nextToken();
						if(st.ttype==StreamTokenizer.TT_WORD) next = st.sval;
						else next = (new Double(st.nval)).toString();
						//only add nodes with isA, hasWant, and collocate
						if(pred.indexOf("isA")!=1||pred.indexOf("hasWant")!=1||pred.indexOf("hasCollocate")!=1){
							Edge e = new Edge(pred,tar,sen,dir,weight);
							node.addEdge(e);
						}
					}
					//System.out.println(nodeName);
					ht.put(nodeName, node);
					//if(!allNodeNames.contains(nodeName)){
						allNodeNames.add(nodeName);
					//}
					
				}
				//System.out.println(".");
			}
		}
		catch(Exception e){
			System.out.println("Error reading "+filename+"; error:"+e);
			/*
			try{st.nextToken();}
			catch(Exception f){}
			System.out.println(st.sval);
			try{st.nextToken();}
						catch(Exception f){}
						System.out.println(st.sval);
			try{st.nextToken();}
						catch(Exception f){}
						System.out.println(st.sval);
			try{st.nextToken();}
						catch(Exception f){}
						System.out.println(st.sval);
			try{st.nextToken();}
						catch(Exception f){}
						System.out.println(st.sval);
						*/
		}
	}

	public Profile createProfile(String prof, String rel, String race, String age){
		Profile profile = new Profile(prof, rel, race, age);
		
		profile = build(profile, prof, 0);
		profile = build(profile, rel, 1);
		profile = build(profile, race, 2);
		profile = build(profile, age, 3);
		
		return profile;
	}
	
	private Profile build (Profile profile, String attribute, int type){
		//first get the attribute node
		AAANode node = this.getNode(attribute.toLowerCase());
		//filter out all the unwanted relations
		Vector wantEdges = node.getEdges();
		//get all hasWant forward edges
		for(int i=wantEdges.size()-1;i>=0;i--){
			Edge wantEdge = (Edge) wantEdges.get(i);
			//if it's a fw hasWant edge, set its weight to 1, and add it to the want node list
			if(wantEdge.Direction.equals("fw")&&wantEdge.Pred.indexOf("hasWant")!=-1&&!isStopWord(wantEdge.Target)){
				switch (type){
					case 0: profile.addProfWantNodes(getNode(wantEdge.Target).setWeight(1).setType("Concept"));break;
					case 1: profile.addRelWantNodes(getNode(wantEdge.Target).setWeight(1).setType("Concept"));break;
					case 2: profile.addRaceWantNodes(getNode(wantEdge.Target).setWeight(1).setType("Concept"));break;
					case 3: profile.addAgeWantNodes(getNode(wantEdge.Target).setWeight(1).setType("Concept"));break;
				}
			}
		}
		
		//now get similar
		Vector wantNodes = new Vector();
		switch (type){
			case 0: wantNodes = profile.getProfNodes(0);break;
			case 1: wantNodes = profile.getRelNodes(0);break;
			case 2: wantNodes = profile.getRaceNodes(0);break;
			case 3: wantNodes = profile.getAgeNodes(0);break;
		}
		
		for(int i=0;i<wantNodes.size();i++){
			AAANode wantNode = (AAANode) wantNodes.get(i);
			Vector similarNodes = getSimilarNodes(wantNode);
			switch (type){
				case 0: profile.getProfNodes(1).insertElementAt(similarNodes, i);break;
				case 1: profile.getRelNodes(1).insertElementAt(similarNodes, i);break;
				case 2: profile.getRaceNodes(1).insertElementAt(similarNodes, i);break;
				case 3: profile.getAgeNodes(1).insertElementAt(similarNodes, i);break;
			}
			
			//now get all bw isA from other nodes containing name (1)
			for(int j=0;j<similarNodes.size();j++){
				AAANode similarNode = (AAANode) similarNodes.get(j);
				Vector bwIsANodes = getBWisANodes(similarNode);
				switch (type){
					case 0: ((Vector) profile.getProfNodes(3).get(i)).insertElementAt(bwIsANodes, j);break;
					case 1: ((Vector) profile.getRelNodes(3).get(i)).insertElementAt(bwIsANodes, j);break;
					case 2: ((Vector) profile.getRaceNodes(3).get(i)).insertElementAt(bwIsANodes, j);break;
					case 3: ((Vector) profile.getAgeNodes(3).get(i)).insertElementAt(bwIsANodes, j);break;
				}
			}
			
		}
		
		//now get collocate nodes
		
		for(int i=0;i<wantNodes.size();i++){
			AAANode wantNode = (AAANode) wantNodes.get(i);
			Vector collocateNodes = getCollocateNodes(wantNode);
			switch (type){
				case 0: profile.getProfNodes(2).insertElementAt(collocateNodes, i);break;
				case 1: profile.getRelNodes(2).insertElementAt(collocateNodes, i);break;
				case 2: profile.getRaceNodes(2).insertElementAt(collocateNodes, i);break;
				case 3: profile.getAgeNodes(2).insertElementAt(collocateNodes, i);break;
			}
		}

		return profile;	
	}

	public boolean isStopWord(String word){
		for(int i=0;i<stopWords.size();i++){
			String stopWord = (String) stopWords.get(i);
			if(word.toLowerCase().equals(stopWord)) return true;
			if(word.toLowerCase().indexOf(" "+stopWord)!=-1) return true;
			if(word.toLowerCase().indexOf(stopWord+" ")!=-1) return true;
		}
		return false;
	}
			

	public static void main(String[] args) {
		
		
		/*
		AAANet aaanet = new AAANet();
		System.out.println("Created net");
		Profile p = aaanet.createProfile("researcher","Protestant","Indian","Child");
		
		System.out.println("Created Profile");
		System.out.println(p);
		
		Vector string = p.toStringVector();
		for(int i=0;i<string.size();i++){
			System.out.println(string.get(i));
		}
		*/
	}
}