package openmind;
import java.util.*;

/**
 * Austin created Node.java at 2:44:35 PM on Nov 16, 2002
 */
public class AAANode {
	public Vector edges;
	public String name;
	public double weight;
	public String type;
	public String target;
	
	public AAANode(String n){
		name = n;
		edges = new Vector();
		type = ""; 
	}
	
	public AAANode (String n, double w){
		name = n;
		edges = new Vector();
		weight = w;
		type = "";
	}
	
	public AAANode (String n, String t, double w){
		name = n;
		edges = new Vector();
		weight = w;
		type = t;
	}
	
	public void addEdge(String p, String t, String s, String d, String w){
  		edges.add(new Edge(p,t,s,d,w));
  		//System.out.println("I just added an edge");
  	}
  	
  	public void addEdge(Edge e){
  		edges.add(e);
  		//System.out.println("I just added an edge");
  	}
  	
  	public Vector getEdges(){
  		if(edges==null) return new Vector();
  		return edges;
  	}
  	
  	public void removeEdge(Edge e){
  		edges.remove(e);	
  	}
  	
  	public AAANode setWeight(double w){
  		this.weight = w;
  		return this;
  	}
  	
	public AAANode setType(String t){
		this.type = t;
		return this;
	}
	
	public AAANode setTarget(String t){
		this.target = t;
		return this;
	}
  	
  	public String toString(){
  		//return name+" "+edges.toString();
  		if(type.length()>0) return type + ": " + name+" "+weight;
  		return name+" "+weight;
  	}
}
