package openmind;


import javax.xml.parsers.*;
import org.xml.sax.*;  

import java.io.*;
import java.net.*;
import org.w3c.dom.*;

import java.util.*;

public class Amazon 
{
    // Global value so it can be ref'd by the tree-adapter
    static Document document; 
    public double iTotalResults;
	
    public Amazon()
    {      
    } // constructor

	public Vector searchAmazon(String keyword, String mode){
		keyword = keyword.replaceAll(" ","%20");
		DocumentBuilderFactory factory =
            DocumentBuilderFactory.newInstance();
            
        try {
           DocumentBuilder builder = factory.newDocumentBuilder();
       	   String completeURL = (new URL("http://xml.amazon.com/onca/xml2?t=webservices-20&dev-t=D10T8CBIC2LCEK&KeywordSearch="+keyword+"&mode="+mode+"&type=heavy&page=1&sort=salesrank&f=xml")).toString();

           document = builder.parse(completeURL);
        } catch (SAXException sxe) {
           // Error generated during parsing)
           Exception  x = sxe;
           if (sxe.getException() != null)
               	x = sxe.getException();
           		x.printStackTrace();

        } catch (ParserConfigurationException pce) {
            // Parser with specified options can't be built
            pce.printStackTrace();

        } catch (IOException ioe) {
           // I/O error
           ioe.printStackTrace();
        }
        catch (Exception e){}
        
        return extractProducts();
	}

	public Vector searchAmazonLite(String keyword, String mode){
		keyword = keyword.replaceAll(" ","%20");
		DocumentBuilderFactory factory =
			DocumentBuilderFactory.newInstance();

		try {
		   DocumentBuilder builder = factory.newDocumentBuilder();
		   String completeURL = (new URL("http://xml.amazon.com/onca/xml2?t=webservices-20&dev-t=D10T8CBIC2LCEK&KeywordSearch="+keyword+"&mode="+mode+"&type=lite&page=1&sort=salesrank&f=xml")).toString();

		   document = builder.parse(completeURL);
		} catch (SAXException sxe) {
		   // Error generated during parsing)
		   Exception  x = sxe;
		   if (sxe.getException() != null)
				x = sxe.getException();
				x.printStackTrace();

		} catch (ParserConfigurationException pce) {
			// Parser with specified options can't be built
			pce.printStackTrace();

		} catch (IOException ioe) {
		   // I/O error
		   ioe.printStackTrace();
		}
		catch (Exception e){}

		return extractProductsLite();
	}


    public static void main(String argv[])
    {
        Amazon a = new Amazon();
        Vector results = a.searchAmazonLite("star wars","books");
        for(int i=0;i<results.size();i++){
        	System.out.println(results.get(i));
        }
      /*  for(int i=0;i<a.AAAnodes.size();i++){
        	AAANode node = (AAANode) a.AAAnodes.get(i);
        	System.out.println(node);
        }
        */
    } // main

 	public Vector extractProducts(){
		NodeList nodes = (NodeList) document.getFirstChild().getChildNodes();
		Vector AAAnodes = new Vector();
 		for(int i = 0; i < nodes.getLength(); i++){
 			Node nItem = nodes.item(i);
 			if(nItem.getNodeName().equals("TotalResults")){
 				iTotalResults = new Double(nItem.getFirstChild().getNodeValue()).doubleValue();
 			}
 			
 			if(nItem.getNodeName().equals("Details")){
 				AAANode anNode = new AAANode(""); 
 				NodeList nlDetailChildren = nItem.getChildNodes();
 				for(int j = 0; j < nlDetailChildren.getLength(); j++){
 					Node nDetailInfo = nlDetailChildren.item(j);
 					if(nDetailInfo.getNodeName().equals("ProductName")){
 						Node nProductName = nDetailInfo.getFirstChild();
 						anNode = new AAANode(nProductName.getNodeValue(), 1/iTotalResults);
 					}
 					if(nDetailInfo.getNodeName().equals("BrowseList")){
 						NodeList nlBrowseList = nDetailInfo.getChildNodes();
						for(int k = 0; k < nlBrowseList.getLength(); k++){
							Node nBrowseNode = nlBrowseList.item(k);
							NodeList nlBrowseName = nBrowseNode.getChildNodes();
							for(int l = 0; l < nlBrowseName.getLength(); l++){
								Node nBrowseName = nlBrowseName.item(l);
								if(nBrowseName.getNodeName().equals("BrowseName")){
									anNode.addEdge(nBrowseName.getFirstChild().getNodeValue(),"","","","");
								}
							}
						}
 					}	
 				}
 				AAAnodes.add(anNode);
 			}
 		}
 		return AAAnodes;
 	}
 	

	public Vector extractProductsLite(){
		NodeList nodes = (NodeList) document.getFirstChild().getChildNodes();
		Vector AAAnodes = new Vector();
		for(int i = 0; i < nodes.getLength(); i++){
			Node nItem = nodes.item(i);
			if(nItem.getNodeName().equals("TotalResults")){
				iTotalResults = new Double(nItem.getFirstChild().getNodeValue()).doubleValue();
			}
	
			if(nItem.getNodeName().equals("Details")){
				AAANode anNode = new AAANode("");
				NodeList nlDetailChildren = nItem.getChildNodes();
				for(int j = 0; j < nlDetailChildren.getLength(); j++){
					Node nDetailInfo = nlDetailChildren.item(j);
					if(nDetailInfo.getNodeName().equals("ProductName")){
						Node nProductName = nDetailInfo.getFirstChild();
						anNode = new AAANode(nProductName.getNodeValue(), 1/iTotalResults);
					}
				}
				AAAnodes.add(anNode);
			}
		}
		return AAAnodes;
	}
 	
 	
}

