package openmind;

import java.util.*;
import java.io.*;
import java.net.*;

public class Connection{
	String url = null;  
    BufferedReader in = null;
    String[] data;  
    int numberResults;
    boolean changed = false;

public Connection(String Url) {
	try{url = Url;}
	catch(Exception e){System.out.println("Bad URL: "+Url);}
}
public Connection(String Url,int num) {
	try{url = Url;}
	catch(Exception e){System.out.println("Bad URL: "+Url);}
	numberResults = num;
	changed = true;
}

public String[] get(String query) {
    StringTokenizer st = new StringTokenizer(query);
    data = new String[st.countTokens()];
    int counter = 0;
    while (st.hasMoreTokens()) {
        try {
        	URL host = new URL(url + "concept=" + st.nextToken());
            if(changed){
            	host = new URL(url + "concept=" + st.nextToken() + "&number=" + numberResults);
            }
            URLConnection con = host.openConnection();
            in = new BufferedReader(new InputStreamReader(con.getInputStream()));

        } catch (UnknownHostException e) {
            System.err.println("Don't know about host: " + url);
            System.exit(1);
        } catch (IOException e) {
            System.err.println("Couldn't get I/O for " + "the connection to: " + url);
            System.exit(1);
        }

        try {
            String temp_data;
            while ((temp_data = in.readLine()) != null) {
                data[counter] += temp_data + "\n";
            }
            in.close();
            counter++;
        } catch (Exception e) {
            System.out.println("Exception while getting data: " + e);
        }
    }
    return data;
}

public String getResults(String input){
	String sResults = "";
	try{
		Connection con = new Connection(url);
	    String[] rsResults = con.get(input);
	    for(int i=0; i < rsResults .length; i++){
			sResults += rsResults [i] + "\n";
    	}
	}
	catch (Exception e){
		System.out.println("Error when connecting to OpenMind: "+e+"; input: "+input+"; results: "+sResults);
	}
	return sResults.substring(5);//gets rid of null
}
    
public void setNumberResults(int num){
	numberResults = num;
	changed = true;
}

public static void main(String[] args) {
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	String word = "";
	
	Connection con = new Connection("http://commonsense.media.mit.edu/cgi-bin/get.cgi?");
	// Prompt
	System.out.println("Type in word:\n> ");
	
	// Read the input
	try {word = input.readLine();}
	catch(Exception e) {}

	System.out.println("Getting word.\n> ");
	String d = con.getResults(word);
	System.out.println(d);
	}
}
