package openmind;

class ContextRules {


	public String[] apply(String[] tag,String[] wd) {

		int tlength = tag.length;

		String[] tcopy = new String[tlength];

		System.arraycopy(tag,0,tcopy,0,tlength);

		// tag:nn>vb <- tag:to@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && tag[i-1].equals("to")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:vbp>vb <- tag:md@[-1,-2,-3]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbp"))
    				if((i-1 >= 0 && tag[i-1].equals("md")) || (i-2 >= 0 && tag[i-2].equals("md")) || (i-3 >= 0 && tag[i-3].equals("md")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:nn>vb <- tag:md@[-1,-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && tag[i-1].equals("md")) || (i-2 >= 0 && tag[i-2].equals("md")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:vb>nn <- tag:dt@[-1,-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("dt")) || (i-2 >= 0 && tag[i-2].equals("dt")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:vbd>vbn <- tag:vbz@[-1,-2,-3]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if((i-1 >= 0 && tag[i-1].equals("vbz")) || (i-2 >= 0 && tag[i-2].equals("vbz")) || (i-3 >= 0 && tag[i-3].equals("vbz")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:prp@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("prp")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:nnp@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("nnp")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vbd>vbn <- tag:vbd@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if((i-1 >= 0 && tag[i-1].equals("vbd")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:vbp>vb <- tag:to@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbp"))
    				if((i-1 >= 0 && tag[i-1].equals("to")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:pos>vbz <- tag:prp@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("pos"))
    				if((i-1 >= 0 && tag[i-1].equals("prp")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:vb>vbp <- tag:nns@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("nns")))
						tcopy[i] = "vbp";
    	tag = tcopy;

		// tag:in>rb <- wd:as@[0]&wd:as@[2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if(wd[i].equals("as") &&
				   (i+2 < tlength && wd[i+2].equals("as")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:vbd>vbn <- wd:have@[-1,-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if((i-1 >= 0 && wd[i-1].equals("have")) || (i-2 >= 0 && wd[i-2].equals("have")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:in>wdt <- tag:vb@[1,2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if((i+1 < tlength && tag[i+1].equals("vb")) || (i+2 < tlength && tag[i+2].equals("vb")))
						tcopy[i] = "wdt";
    	tag = tcopy;

		// tag:vb>vbp <- tag:prp@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("prp")))
						tcopy[i] = "vbp";
    	tag = tcopy;

		// tag:vbp>vb <- wd:n't@[-1,-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbp"))
    				if((i-1 >= 0 && wd[i-1].equals("n't")) || (i-2 >= 0 && wd[i-2].equals("n't")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:in>wdt <- tag:vbz@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if((i+1 < tlength && tag[i+1].equals("vbz")))
						tcopy[i] = "wdt";
    	tag = tcopy;

		// tag:in>dt <- tag:nn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if((i+1 < tlength && tag[i+1].equals("nn")))
						tcopy[i] = "dt";
    	tag = tcopy;

		// tag:jj>nnp <- tag:nnp@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i+1 < tlength && tag[i+1].equals("nnp")))
						tcopy[i] = "nnp";
    	tag = tcopy;

		// tag:in>wdt <- tag:vbd@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if((i+1 < tlength && tag[i+1].equals("vbd")))
						tcopy[i] = "wdt";
    	tag = tcopy;

		// tag:jj>nn <- wd:of@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i+1 < tlength && wd[i+1].equals("of")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:vbd>vbn <- wd:be@[-1,-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if((i-1 >= 0 && wd[i-1].equals("be")) || (i-2 >= 0 && wd[i-2].equals("be")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:jjr>rbr <- tag:jj@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jjr"))
    				if((i+1 < tlength && tag[i+1].equals("jj")))
						tcopy[i] = "rbr";
    	tag = tcopy;

		// tag:in>wdt <- tag:vbp@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if((i+1 < tlength && tag[i+1].equals("vbp")))
						tcopy[i] = "wdt";
    	tag = tcopy;

		// tag:jjs>rbs <- wd:most@[0]&tag:jj@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jjs"))
    				if(wd[i].equals("most") &&
				   (i+1 < tlength && tag[i+1].equals("jj")))
						tcopy[i] = "rbs";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:nn@[-1]&tag:dt@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("nn")) &&
				   (i+1 < tlength && tag[i+1].equals("dt")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:nns>vbz <- tag:prp@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nns"))
    				if((i-1 >= 0 && tag[i-1].equals("prp")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:pos>vbz <- tag:dt@[1,2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("pos"))
    				if((i+1 < tlength && tag[i+1].equals("dt")) || (i+2 < tlength && tag[i+2].equals("dt")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:nnp>nn <- tag:start@[-1]&tag:nns@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if((i-1 >= 0 && tag[i-1].equals("start")) &&
				   (i+1 < tlength && tag[i+1].equals("nns")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:vbd>vbn <- wd:by@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if((i+1 < tlength && wd[i+1].equals("by")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:vb>nn <- tag:in@[-1,-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("in")) || (i-2 >= 0 && tag[i-2].equals("in")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:vb>vbp <- tag:wdt@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("wdt")))
						tcopy[i] = "vbp";
    	tag = tcopy;

		// tag:vbg>nn <- tag:jj@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbg"))
    				if((i-1 >= 0 && tag[i-1].equals("jj")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:nns>vbz <- tag:dt@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nns"))
    				if((i+1 < tlength && tag[i+1].equals("dt")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:WP@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("WP")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:nn>vbp <- tag:nns@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && tag[i-1].equals("nns")))
						tcopy[i] = "vbp";
    	tag = tcopy;

		// tag:vb>nn <- tag:nn@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("nn")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:nn>vb <- wd:n't@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && wd[i-1].equals("n't")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:nn>vbg <- tag:dt@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i+1 < tlength && tag[i+1].equals("dt")))
						tcopy[i] = "vbg";
    	tag = tcopy;

		// tag:rb>jj <- tag:nn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rb"))
    				if((i+1 < tlength && tag[i+1].equals("nn")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:nn>vbp <- tag:prp@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && tag[i-1].equals("prp")))
						tcopy[i] = "vbp";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:nns@[-1]&tag:dt@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("nns")) &&
				   (i+1 < tlength && tag[i+1].equals("dt")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vb>nn <- tag:pos@[-1,-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("pos")) || (i-2 >= 0 && tag[i-2].equals("pos")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:jj>nn <- tag:vbd@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i+1 < tlength && tag[i+1].equals("vbd")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:rb>rp <- wd:up@[0]&tag:dt@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rb"))
    				if(wd[i].equals("up") &&
				   (i+1 < tlength && tag[i+1].equals("dt")))
						tcopy[i] = "rp";
    	tag = tcopy;

		// tag:jj>vb <- tag:to@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i-1 >= 0 && tag[i-1].equals("to")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:,@[-1]&tag:dt@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals(",")) &&
				   (i+1 < tlength && tag[i+1].equals("dt")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vbn>vbd <- wd:that@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && wd[i-1].equals("that")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vb>vbp <- tag:nns@[-1]&tag:rb@[-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("nns")) &&
				   (i-2 >= 0 && tag[i-2].equals("rb")))
						tcopy[i] = "vbp";
    	tag = tcopy;

		// tag:nnp>jj <- tag:start@[-1]&tag:nn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if((i-1 >= 0 && tag[i-1].equals("start")) &&
				   (i+1 < tlength && tag[i+1].equals("nn")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:vb>vbn <- tag:vbz@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("vbz")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:nnp>jj <- wd:American@[0]&tag:nns@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if(wd[i].equals("American") &&
				   (i+1 < tlength && tag[i+1].equals("nns")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:jj>rb <- tag:jjr@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i+1 < tlength && tag[i+1].equals("jjr")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:nns>nn <- wd:yen@[0]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nns"))
    				if(wd[i].equals("yen"))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:in>wdt <- tag:vbd@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if((i+1 < tlength && tag[i+1].equals("vbd")))
						tcopy[i] = "wdt";
    	tag = tcopy;

		// tag:dt>in <- wd:that@[0]&tag:nns@[2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("dt"))
    				if(wd[i].equals("that") &&
				   (i+2 < tlength && tag[i+2].equals("nns")))
						tcopy[i] = "in";
    	tag = tcopy;

		// tag:pos>vbz <- wd:that@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("pos"))
    				if((i-1 >= 0 && wd[i-1].equals("that")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:jj>vb <- tag:md@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i-1 >= 0 && tag[i-1].equals("md")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:vb>nn <- tag:jj@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("jj")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:jjr>rbr <- tag:rb@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jjr"))
    				if((i+1 < tlength && tag[i+1].equals("rb")))
						tcopy[i] = "rbr";
    	tag = tcopy;

		// tag:vbd>vbn <- wd:are@[-1,-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if((i-1 >= 0 && wd[i-1].equals("are")) || (i-2 >= 0 && wd[i-2].equals("are")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:nn>jj <- wd:executive@[0]&tag:nn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if(wd[i].equals("executive") &&
				   (i+1 < tlength && tag[i+1].equals("nn")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:nnp>jj <- wd:American@[0]&tag:nn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if(wd[i].equals("American") &&
				   (i+1 < tlength && tag[i+1].equals("nn")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:wdt@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("wdt")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vbd>vbn <- tag:vbd@[-1]&tag:rb@[-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if((i-1 >= 0 && tag[i-1].equals("vbd")) &&
				   (i-2 >= 0 && tag[i-2].equals("rb")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:jj>nn <- tag:dt@[-1]&tag:.@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i-1 >= 0 && tag[i-1].equals("dt")) &&
				   (i+1 < tlength && tag[i+1].equals(".")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:nnp>jj <- wd:German@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if((i+1 < tlength && wd[i+1].equals("German")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:vbn>vb <- tag:to@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("to")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:nnp@[-1]&tag:rb@[-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("nnp")) &&
				   (i-2 >= 0 && tag[i-2].equals("rb")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:rb>in <- wd:to@[0]&wd:up@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rb"))
    				if(wd[i].equals("to") &&
				   (i+1 < tlength && wd[i+1].equals("up")))
						tcopy[i] = "in";
    	tag = tcopy;

		// tag:vb>vbp <- tag:WP@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("WP")))
						tcopy[i] = "vbp";
    	tag = tcopy;

		// tag:jj>nn <- tag:dt@[-1]&tag:in@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i-1 >= 0 && tag[i-1].equals("dt")) &&
				   (i+1 < tlength && tag[i+1].equals("in")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:in>dt <- wd:'s@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if((i+1 < tlength && wd[i+1].equals("'s")))
						tcopy[i] = "dt";
    	tag = tcopy;

		// tag:vbd>vbn <- wd:ended@[0]&tag:nnp@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if(wd[i].equals("ended") &&
				   (i+1 < tlength && tag[i+1].equals("nnp")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:vbd>vbn <- tag:dt@[-1]&tag:nn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if((i-1 >= 0 && tag[i-1].equals("dt")) &&
				   (i+1 < tlength && tag[i+1].equals("nn")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:nns>nnp <- tag:nnp@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nns"))
    				if((i+1 < tlength && tag[i+1].equals("nnp")))
						tcopy[i] = "nnp";
    	tag = tcopy;

		// tag:nn>nnp <- tag:nnp@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i+1 < tlength && tag[i+1].equals("nnp")))
						tcopy[i] = "nnp";
    	tag = tcopy;

		// tag:vbg>nn <- tag:dt@[-1]&tag:in@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbg"))
    				if((i-1 >= 0 && tag[i-1].equals("dt")) &&
				   (i+1 < tlength && tag[i+1].equals("in")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:nnp>jj <- tag:start@[-1]&tag:nns@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if((i-1 >= 0 && tag[i-1].equals("start")) &&
				   (i+1 < tlength && tag[i+1].equals("nns")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:rb>rp <- wd:vb@[0]&tag:up@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rb"))
    				if(wd[i].equals("vb") &&
				   (i-1 >= 0 && tag[i-1].equals("up")))
						tcopy[i] = "rp";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:prp@[-1]&tag:rb@[-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("prp")) &&
				   (i-2 >= 0 && tag[i-2].equals("rb")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:jj>rb <- tag:vbn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i+1 < tlength && tag[i+1].equals("vbn")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:nn>vbp <- tag:rb@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && tag[i-1].equals("rb")))
						tcopy[i] = "vbp";
    	tag = tcopy;

		// tag:nns>vbz <- tag:rb@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nns"))
    				if((i-1 >= 0 && tag[i-1].equals("rb")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:pos>vbz <- tag:WP@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("pos"))
    				if((i-1 >= 0 && tag[i-1].equals("WP")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:vb>vbn <- wd:have@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && wd[i-1].equals("have")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:nn>PDT <- wd:half@[0]&tag:dt@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if(wd[i].equals("half") &&
				   (i+1 < tlength && tag[i+1].equals("dt")))
						tcopy[i] = "PDT";
    	tag = tcopy;

		// tag:in>dt <- tag:in@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if((i-1 >= 0 && tag[i-1].equals("in")))
						tcopy[i] = "dt";
    	tag = tcopy;

		// tag:in>wdt <- tag:md@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if((i+1 < tlength && tag[i+1].equals("md")))
						tcopy[i] = "wdt";
    	tag = tcopy;

		// tag:pos>vbz <- tag:dt@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("pos"))
    				if((i-1 >= 0 && tag[i-1].equals("dt")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:nn>nnp <- wd:Integrated@[0]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if(wd[i].equals("Integrated"))
						tcopy[i] = "nnp";
    	tag = tcopy;

		// tag:pos>'' <- tag:''@[1,2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("pos"))
    				if((i+1 < tlength && tag[i+1].equals("''")) || (i+2 < tlength && tag[i+2].equals("''")))
						tcopy[i] = "''";
    	tag = tcopy;

		// tag:vbd>vbn <- tag:in@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if((i-1 >= 0 && tag[i-1].equals("in")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:jjr>rbr <- tag:vbn@[1,2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jjr"))
    				if((i+1 < tlength && tag[i+1].equals("vbn")) || (i+2 < tlength && tag[i+2].equals("vbn")))
						tcopy[i] = "rbr";
    	tag = tcopy;

		// tag:jjs>rbs <- wd:most@[0]&tag:rb@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jjs"))
    				if(wd[i].equals("most") &&
				   (i+1 < tlength && tag[i+1].equals("rb")))
						tcopy[i] = "rbs";
    	tag = tcopy;

		// tag:jj>nn <- tag:jj@[-1]&tag:in@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i-1 >= 0 && tag[i-1].equals("jj")) &&
				   (i+1 < tlength && tag[i+1].equals("in")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:vbz>nns <- tag:jj@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbz"))
    				if((i-1 >= 0 && tag[i-1].equals("jj")))
						tcopy[i] = "nns";
    	tag = tcopy;

		// tag:nns>vbz <- wd:jj@[0]&tag:is@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nns"))
    				if(wd[i].equals("jj") &&
				   (i-1 >= 0 && tag[i-1].equals("is")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:jj>nn <- tag:vbz@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i+1 < tlength && tag[i+1].equals("vbz")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:vbp>nn <- tag:dt@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbp"))
    				if((i-1 >= 0 && tag[i-1].equals("dt")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:jj>nn <- tag:jj@[-1]&tag:.@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i-1 >= 0 && tag[i-1].equals("jj")) &&
				   (i+1 < tlength && tag[i+1].equals(".")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:nnps>nnp <- tag:nnp@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnps"))
    				if((i+1 < tlength && tag[i+1].equals("nnp")))
						tcopy[i] = "nnp";
    	tag = tcopy;

		// tag:wdt>dt <- tag:cc@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("wdt"))
    				if((i-1 >= 0 && tag[i-1].equals("cc")))
						tcopy[i] = "dt";
    	tag = tcopy;

		// tag:rb>in <- wd:so@[0]&tag:prp@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rb"))
    				if(wd[i].equals("so") &&
				   (i+1 < tlength && tag[i+1].equals("prp")))
						tcopy[i] = "in";
    	tag = tcopy;

		// tag:vbp>nn <- wd:earnings@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbp"))
    				if((i-1 >= 0 && wd[i-1].equals("earnings")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:nn>vbg <- wd:is@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && wd[i-1].equals("is")))
						tcopy[i] = "vbg";
    	tag = tcopy;

		// tag:nns>vbz <- wd:Mr.@[-1,-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nns"))
    				if((i-1 >= 0 && wd[i-1].equals("Mr.")) || (i-2 >= 0 && wd[i-2].equals("Mr.")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:vbz>nns <- wd:the@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbz"))
    				if((i-1 >= 0 && wd[i-1].equals("the")))
						tcopy[i] = "nns";
    	tag = tcopy;

		// tag:rb>rp <- wd:vbn@[0]&tag:up@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rb"))
    				if(wd[i].equals("vbn") &&
				   (i-1 >= 0 && tag[i-1].equals("up")))
						tcopy[i] = "rp";
    	tag = tcopy;

		// tag:nnps>nns <- tag:start@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnps"))
    				if((i-1 >= 0 && tag[i-1].equals("start")))
						tcopy[i] = "nns";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:nn@[-1]&tag:jj@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("nn")) &&
				   (i+1 < tlength && tag[i+1].equals("jj")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vbp>vb <- tag:vb@[-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbp"))
    				if((i-2 >= 0 && tag[i-2].equals("vb")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:rbr>jjr <- tag:nns@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rbr"))
    				if((i+1 < tlength && tag[i+1].equals("nns")))
						tcopy[i] = "jjr";
    	tag = tcopy;

		// tag:jj>nn <- tag:dt@[-1]&tag:,@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i-1 >= 0 && tag[i-1].equals("dt")) &&
				   (i+1 < tlength && tag[i+1].equals(",")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:jj>nn <- tag:in@[-1]&tag:.@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i-1 >= 0 && tag[i-1].equals("in")) &&
				   (i+1 < tlength && tag[i+1].equals(".")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:nn>vb <- tag:to@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && tag[i-1].equals("to")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:vb>nn <- tag:vb@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("vb")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:nn>vbp <- wd:who@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && wd[i-1].equals("who")))
						tcopy[i] = "vbp";
    	tag = tcopy;

		// tag:rb>rp <- wd:vbg@[0]&tag:up@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rb"))
    				if(wd[i].equals("vbg") &&
				   (i-1 >= 0 && tag[i-1].equals("up")))
						tcopy[i] = "rp";
    	tag = tcopy;

		// tag:nn>rb <- wd:right@[0]&tag:rb@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if(wd[i].equals("right") &&
				   (i+1 < tlength && tag[i+1].equals("rb")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:vbz>pos <- wd:nnp@[0]&tag:'s@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbz"))
    				if(wd[i].equals("nnp") &&
				   (i-1 >= 0 && tag[i-1].equals("'s")))
						tcopy[i] = "pos";
    	tag = tcopy;

		// tag:jj>rp <- wd:up@[0]&tag:nn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if(wd[i].equals("up") &&
				   (i+1 < tlength && tag[i+1].equals("nn")))
						tcopy[i] = "rp";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:nn@[-1]&tag:nn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("nn")) &&
				   (i+1 < tlength && tag[i+1].equals("nn")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:cc@[-1]&tag:dt@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("cc")) &&
				   (i+1 < tlength && tag[i+1].equals("dt")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:jj>nn <- tag:md@[1]&tag:vb@[2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i+1 < tlength && tag[i+1].equals("md")) &&
				   (i+2 < tlength && tag[i+2].equals("vb")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:jj>rb <- wd:early@[0]&tag:in@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if(wd[i].equals("early") &&
				   (i+1 < tlength && tag[i+1].equals("in")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:jj>vbn <- tag:start@[-1]&tag:in@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i-1 >= 0 && tag[i-1].equals("start")) &&
				   (i+1 < tlength && tag[i+1].equals("in")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:in>rb <- wd:,@[0]&wd:though@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if(wd[i].equals(",") &&
				   (i+1 < tlength && wd[i+1].equals("though")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:vbd>vbn <- wd:been@[-1,-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if((i-1 >= 0 && wd[i-1].equals("been")) || (i-2 >= 0 && wd[i-2].equals("been")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:dt>PDT <- wd:all@[0]&tag:dt@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("dt"))
    				if(wd[i].equals("all") &&
				   (i+1 < tlength && tag[i+1].equals("dt")))
						tcopy[i] = "PDT";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:nn@[-1]&tag:rb@[-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("nn")) &&
				   (i-2 >= 0 && tag[i-2].equals("rb")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:nn>vb <- wd:help@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && wd[i-1].equals("help")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:vbp>vb <- wd:not@[-1,-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbp"))
    				if((i-1 >= 0 && wd[i-1].equals("not")) || (i-2 >= 0 && wd[i-2].equals("not")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:vbp>nn <- tag:jj@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbp"))
    				if((i-1 >= 0 && tag[i-1].equals("jj")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:dt>wdt <- tag:nns@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("dt"))
    				if((i-1 >= 0 && tag[i-1].equals("nns")))
						tcopy[i] = "wdt";
    	tag = tcopy;

		// tag:nn>vbp <- tag:wdt@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && tag[i-1].equals("wdt")))
						tcopy[i] = "vbp";
    	tag = tcopy;

		// tag:vb>rb <- wd:to@[0]&wd:close@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if(wd[i].equals("to") &&
				   (i+1 < tlength && wd[i+1].equals("close")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:nns>vbz <- tag:,@[-1]&tag:wdt@[-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nns"))
    				if((i-1 >= 0 && tag[i-1].equals(",")) &&
				   (i-2 >= 0 && tag[i-2].equals("wdt")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:in>rp <- wd:out@[0]&tag:dt@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if(wd[i].equals("out") &&
				   (i+1 < tlength && tag[i+1].equals("dt")))
						tcopy[i] = "rp";
    	tag = tcopy;

		// tag:dt>rb <- wd:longer@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("dt"))
    				if((i+1 < tlength && wd[i+1].equals("longer")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:in>jj <- tag:dt@[-1]&tag:nn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if((i-1 >= 0 && tag[i-1].equals("dt")) &&
				   (i+1 < tlength && tag[i+1].equals("nn")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:dt>wdt <- tag:nn@[-1]&tag:vbz@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("dt"))
    				if((i-1 >= 0 && tag[i-1].equals("nn")) &&
				   (i+1 < tlength && tag[i+1].equals("vbz")))
						tcopy[i] = "wdt";
    	tag = tcopy;

		// tag:in>vb <- tag:vb@[2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if((i+2 < tlength && tag[i+2].equals("vb")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:in>nn <- tag:dt@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if((i-1 >= 0 && tag[i-1].equals("dt")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:nns@[-1]&tag:nns@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("nns")) &&
				   (i+1 < tlength && tag[i+1].equals("nns")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:in>rb <- wd: $ @[0]&wd:about@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if(wd[i].equals("$") &&
				   (i+1 < tlength && wd[i+1].equals("about")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:EX>rb <- tag:in@[1,2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("EX"))
    				if((i+1 < tlength && tag[i+1].equals("in")) || (i+2 < tlength && tag[i+2].equals("in")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:nn>vbg <- tag:prp$@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i+1 < tlength && tag[i+1].equals("prp$")))
						tcopy[i] = "vbg";
    	tag = tcopy;

		// tag:nn>vbg <- wd:living@[0]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if(wd[i].equals("living"))
						tcopy[i] = "vbg";
    	tag = tcopy;

		// tag:vbz>nns <- tag:prp$@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbz"))
    				if((i-1 >= 0 && tag[i-1].equals("prp$")))
						tcopy[i] = "nns";
    	tag = tcopy;

		// tag:rbr>jjr <- tag:nn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rbr"))
    				if((i+1 < tlength && tag[i+1].equals("nn")))
						tcopy[i] = "jjr";
    	tag = tcopy;

		// tag:rbr>jjr <- wd:higher@[0]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rbr"))
    				if(wd[i].equals("higher"))
						tcopy[i] = "jjr";
    	tag = tcopy;

		// tag:vb>vbp <- tag:prp@[-1]&tag:rb@[-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("prp")) &&
				   (i-2 >= 0 && tag[i-2].equals("rb")))
						tcopy[i] = "vbp";
    	tag = tcopy;

		// tag:nn>vb <- tag:md@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && tag[i-1].equals("md")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:vb>nn <- tag:prp$@[-1,-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("prp$")) || (i-2 >= 0 && tag[i-2].equals("prp$")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:rp>in <- tag:,@[-1,-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rp"))
    				if((i-1 >= 0 && tag[i-1].equals(",")) || (i-2 >= 0 && tag[i-2].equals(",")))
						tcopy[i] = "in";
    	tag = tcopy;

		// tag:vb>jj <- tag:dt@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("dt")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:dt>in <- wd:out@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("dt"))
    				if((i-1 >= 0 && wd[i-1].equals("out")))
						tcopy[i] = "in";
    	tag = tcopy;

		// tag:pos>vbz <- tag:EX@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("pos"))
    				if((i-1 >= 0 && tag[i-1].equals("EX")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:jj>nn <- tag:pos@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i+1 < tlength && tag[i+1].equals("pos")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:nn>jj <- wd:first@[0]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if(wd[i].equals("first"))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:vbd>vbn <- wd:the@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if((i-1 >= 0 && wd[i-1].equals("the")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:nns>vbz <- wd:nnp@[0]&tag:plans@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nns"))
    				if(wd[i].equals("nnp") &&
				   (i-1 >= 0 && tag[i-1].equals("plans")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:nnp>nns <- tag:start@[-1]&tag:in@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if((i-1 >= 0 && tag[i-1].equals("start")) &&
				   (i+1 < tlength && tag[i+1].equals("in")))
						tcopy[i] = "nns";
    	tag = tcopy;

		// tag:rb>jj <- tag:nns@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rb"))
    				if((i+1 < tlength && tag[i+1].equals("nns")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:jj>rb <- wd:just@[0]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if(wd[i].equals("just"))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:vbp>nn <- wd:sales@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbp"))
    				if((i-1 >= 0 && wd[i-1].equals("sales")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:nns>nnps <- wd:Orange@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nns"))
    				if((i-1 >= 0 && wd[i-1].equals("Orange")))
						tcopy[i] = "nnps";
    	tag = tcopy;

		// tag:vb>vbn <- tag:vbd@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("vbd")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:wdt>dt <- tag:in@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("wdt"))
    				if((i-1 >= 0 && tag[i-1].equals("in")))
						tcopy[i] = "dt";
    	tag = tcopy;

		// tag:nn>jj <- wd:right@[0]&tag:nn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if(wd[i].equals("right") &&
				   (i+1 < tlength && tag[i+1].equals("nn")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:nn>vbg <- wd:operating@[0]&tag:in@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if(wd[i].equals("operating") &&
				   (i+1 < tlength && tag[i+1].equals("in")))
						tcopy[i] = "vbg";
    	tag = tcopy;

		// tag:jj>vbn <- wd:insured@[0]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if(wd[i].equals("insured"))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:jj>nnp <- wd:start@[0]&wd:U.S.@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if(wd[i].equals("start") &&
				   (i-1 >= 0 && wd[i-1].equals("U.S.")))
						tcopy[i] = "nnp";
    	tag = tcopy;

		// tag:in>dt <- tag:start@[1,2,3]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if((i+1 < tlength && tag[i+1].equals("start")) || (i+2 < tlength && tag[i+2].equals("start")) || (i+3 < tlength && tag[i+3].equals("start")))
						tcopy[i] = "dt";
    	tag = tcopy;

		// tag:pos>'' <- tag: `` @[-1,-2,-3]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("pos"))
    				if((i-1 >= 0 && tag[i-1].equals("``")) || (i-2 >= 0 && tag[i-2].equals("``")) || (i-3 >= 0 && tag[i-3].equals("``")))
						tcopy[i] = "''";
    	tag = tcopy;

		// tag:nn>jj <- wd:official@[0]&tag:nn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if(wd[i].equals("official") &&
				   (i+1 < tlength && tag[i+1].equals("nn")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:nnp>jj <- wd:Irish@[0]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if(wd[i].equals("Irish"))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:jj>rb <- tag:rbr@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i+1 < tlength && tag[i+1].equals("rbr")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:vbg>nn <- wd:dt@[0]&tag:selling@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbg"))
    				if(wd[i].equals("dt") &&
				   (i-1 >= 0 && tag[i-1].equals("selling")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:vbp>vb <- tag:md@[-1,-2,-3]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbp"))
    				if((i-1 >= 0 && tag[i-1].equals("md")) || (i-2 >= 0 && tag[i-2].equals("md")) || (i-3 >= 0 && tag[i-3].equals("md")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:wdt>in <- tag:prp@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("wdt"))
    				if((i+1 < tlength && tag[i+1].equals("prp")))
						tcopy[i] = "in";
    	tag = tcopy;

		// tag:EX>rb <- tag:.@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("EX"))
    				if((i+1 < tlength && tag[i+1].equals(".")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:nns@[-1]&tag:prp$@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("nns")) &&
				   (i+1 < tlength && tag[i+1].equals("prp$")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vbn>vbd <- wd:said@[0]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if(wd[i].equals("said"))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:jj>rb <- tag:md@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i-1 >= 0 && tag[i-1].equals("md")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:nn>vbg <- tag:jj@[1]&tag:nns@[2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i+1 < tlength && tag[i+1].equals("jj")) &&
				   (i+2 < tlength && tag[i+2].equals("nns")))
						tcopy[i] = "vbg";
    	tag = tcopy;

		// tag:jj>rb <- wd:late@[0]&tag:in@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if(wd[i].equals("late") &&
				   (i+1 < tlength && tag[i+1].equals("in")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:vbg>nn <- tag:prp$@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbg"))
    				if((i-1 >= 0 && tag[i-1].equals("prp$")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:vbz>nns <- tag:vbp@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbz"))
    				if((i+1 < tlength && tag[i+1].equals("vbp")))
						tcopy[i] = "nns";
    	tag = tcopy;

		// tag:nn>nnp <- wd:dt@[0]&tag:cd@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if(wd[i].equals("dt") &&
				   (i-1 >= 0 && tag[i-1].equals("cd")))
						tcopy[i] = "nnp";
    	tag = tcopy;

		// tag:nn>vbn <- wd:be@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && wd[i-1].equals("be")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:jjs>rbs <- tag:vbn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jjs"))
    				if((i+1 < tlength && tag[i+1].equals("vbn")))
						tcopy[i] = "rbs";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:nn@[-1]&tag:prp$@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("nn")) &&
				   (i+1 < tlength && tag[i+1].equals("prp$")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:nns@[-1]&tag:jj@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("nns")) &&
				   (i+1 < tlength && tag[i+1].equals("jj")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:nns@[-1]&tag:nn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("nns")) &&
				   (i+1 < tlength && tag[i+1].equals("nn")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vbd>vbn <- wd:increased@[0]&tag:nn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if(wd[i].equals("increased") &&
				   (i+1 < tlength && tag[i+1].equals("nn")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:vbz>nns <- wd:of@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbz"))
    				if((i+1 < tlength && wd[i+1].equals("of")))
						tcopy[i] = "nns";
    	tag = tcopy;

		// tag:in>rp <- wd:out@[0]&tag:nns@[2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if(wd[i].equals("out") &&
				   (i+2 < tlength && tag[i+2].equals("nns")))
						tcopy[i] = "rp";
    	tag = tcopy;

		// tag:jj>nnp <- tag:pos@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i+1 < tlength && tag[i+1].equals("pos")))
						tcopy[i] = "nnp";
    	tag = tcopy;

		// tag:rb>rp <- wd:down@[0]&tag:dt@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rb"))
    				if(wd[i].equals("down") &&
				   (i+1 < tlength && tag[i+1].equals("dt")))
						tcopy[i] = "rp";
    	tag = tcopy;

		// tag:cd>nns <- wd:1970s@[0]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("cd"))
    				if(wd[i].equals("1970s"))
						tcopy[i] = "nns";
    	tag = tcopy;

		// tag:vbg>nnp <- wd:Working@[0]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbg"))
    				if(wd[i].equals("Working"))
						tcopy[i] = "nnp";
    	tag = tcopy;

		// tag:vbn>vb <- tag:md@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("md")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:jj>nn <- tag:cc@[1]&tag:nn@[2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i+1 < tlength && tag[i+1].equals("cc")) &&
				   (i+2 < tlength && tag[i+2].equals("nn")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:nn>jj <- tag:start@[-1]&tag:nns@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && tag[i-1].equals("start")) &&
				   (i+1 < tlength && tag[i+1].equals("nns")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:,@[-1]&tag:cc@[-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals(",")) &&
				   (i-2 >= 0 && tag[i-2].equals("cc")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:in>rb <- tag:.@[1]&tag:start@[2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if((i+1 < tlength && tag[i+1].equals(".")) &&
				   (i+2 < tlength && tag[i+2].equals("start")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:nn>vbg <- wd:was@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && wd[i-1].equals("was")))
						tcopy[i] = "vbg";
    	tag = tcopy;

		// tag:nnp>nnps <- wd:Cowboys@[0]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if(wd[i].equals("Cowboys"))
						tcopy[i] = "nnps";
    	tag = tcopy;

		// tag:vbz>nns <- wd:phone@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbz"))
    				if((i-1 >= 0 && wd[i-1].equals("phone")))
						tcopy[i] = "nns";
    	tag = tcopy;

		// tag:nnp>nns <- tag:start@[-1]&tag:vbp@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if((i-1 >= 0 && tag[i-1].equals("start")) &&
				   (i+1 < tlength && tag[i+1].equals("vbp")))
						tcopy[i] = "nns";
    	tag = tcopy;

		// tag:rbr>jjr <- wd:lower@[0]&tag:jj@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rbr"))
    				if(wd[i].equals("lower") &&
				   (i+1 < tlength && tag[i+1].equals("jj")))
						tcopy[i] = "jjr";
    	tag = tcopy;

		// tag:prp$>prp <- tag:in@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("prp$"))
    				if((i+1 < tlength && tag[i+1].equals("in")))
						tcopy[i] = "prp";
    	tag = tcopy;

		// tag:vbd>vb <- tag:to@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if((i-1 >= 0 && tag[i-1].equals("to")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:jj>nn <- wd:nn@[0]&tag:chief@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if(wd[i].equals("nn") &&
				   (i-1 >= 0 && tag[i-1].equals("chief")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:jj>nn <- tag:jj@[-1]&tag:,@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i-1 >= 0 && tag[i-1].equals("jj")) &&
				   (i+1 < tlength && tag[i+1].equals(",")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:nn>jj <- wd:dt@[0]&tag:third@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if(wd[i].equals("dt") &&
				   (i-1 >= 0 && tag[i-1].equals("third")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:nns@[-1]&tag:nnp@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("nns")) &&
				   (i+1 < tlength && tag[i+1].equals("nnp")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:nnp>nn <- tag:start@[-1]&tag:nn@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if((i-1 >= 0 && tag[i-1].equals("start")) &&
				   (i+1 < tlength && tag[i+1].equals("nn")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:nnp>nn <- wd:HDTV@[0]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if(wd[i].equals("HDTV"))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:vbg>nn <- tag:dt@[-1]&tag:,@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbg"))
    				if((i-1 >= 0 && tag[i-1].equals("dt")) &&
				   (i+1 < tlength && tag[i+1].equals(",")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:vbg>nn <- tag:dt@[-1]&tag:.@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbg"))
    				if((i-1 >= 0 && tag[i-1].equals("dt")) &&
				   (i+1 < tlength && tag[i+1].equals(".")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:nns>vbz <- tag:WP@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nns"))
    				if((i-1 >= 0 && tag[i-1].equals("WP")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:nn>vb <- tag:cc@[-1]&tag:dt@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && tag[i-1].equals("cc")) &&
				   (i+1 < tlength && tag[i+1].equals("dt")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:nnps>nnp <- wd:in@[0]&tag:Securities@[-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnps"))
    				if(wd[i].equals("in") &&
				   (i-2 >= 0 && tag[i-2].equals("Securities")))
						tcopy[i] = "nnp";
    	tag = tcopy;

		// tag:rp>in <- tag:nns@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rp"))
    				if((i-1 >= 0 && tag[i-1].equals("nns")))
						tcopy[i] = "in";
    	tag = tcopy;

		// tag:vbp>nn <- wd:funds@[0]&wd:rate@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbp"))
    				if(wd[i].equals("funds") &&
				   (i-1 >= 0 && wd[i-1].equals("rate")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:vbp>nn <- wd:nns@[0]&tag:market@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbp"))
    				if(wd[i].equals("nns") &&
				   (i-1 >= 0 && tag[i-1].equals("market")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:dt>rb <- wd:.@[0]&wd:either@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("dt"))
    				if(wd[i].equals(".") &&
				   (i+1 < tlength && wd[i+1].equals("either")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:vbn>nn <- tag:dt@[-1]&tag:in@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("dt")) &&
				   (i+1 < tlength && tag[i+1].equals("in")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:vbd>vb <- tag:md@[-1,-2,-3]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if((i-1 >= 0 && tag[i-1].equals("md")) || (i-2 >= 0 && tag[i-2].equals("md")) || (i-3 >= 0 && tag[i-3].equals("md")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:nn>jj <- wd:oil@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i+1 < tlength && wd[i+1].equals("oil")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:,@[-1]&tag: $ @[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals(",")) &&
				   (i+1 < tlength && tag[i+1].equals("$")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vbd>vbn <- tag:dt@[-1]&tag:rb@[-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if((i-1 >= 0 && tag[i-1].equals("dt")) &&
				   (i-2 >= 0 && tag[i-2].equals("rb")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:vbn>jj <- wd:by@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && wd[i-1].equals("by")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:nnp>jj <- wd:American@[0]&tag:jj@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if(wd[i].equals("American") &&
				   (i+1 < tlength && tag[i+1].equals("jj")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:nn>vbg <- tag:vbp@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && tag[i-1].equals("vbp")))
						tcopy[i] = "vbg";
    	tag = tcopy;

		// tag:jj>rb <- wd:very@[0]&wd:much@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if(wd[i].equals("very") &&
				   (i-1 >= 0 && wd[i-1].equals("much")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:nn>vbg <- wd:officer@[0]&wd:operating@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if(wd[i].equals("officer") &&
				   (i+1 < tlength && wd[i+1].equals("operating")))
						tcopy[i] = "vbg";
    	tag = tcopy;

		// tag:rb>in <- wd:for@[0]&wd:up@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rb"))
    				if(wd[i].equals("for") &&
				   (i+1 < tlength && wd[i+1].equals("up")))
						tcopy[i] = "in";
    	tag = tcopy;

		// tag:nns>vbz <- tag:jj@[1]&tag:nns@[2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nns"))
    				if((i+1 < tlength && tag[i+1].equals("jj")) &&
				   (i+2 < tlength && tag[i+2].equals("nns")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:nns>vbz <- tag:,@[-1]&tag:in@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nns"))
    				if((i-1 >= 0 && tag[i-1].equals(",")) &&
				   (i+1 < tlength && tag[i+1].equals("in")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:vb>vbp <- tag:nnps@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i-1 >= 0 && tag[i-1].equals("nnps")))
						tcopy[i] = "vbp";
    	tag = tcopy;

		// tag:in>rp <- wd:out@[0]&tag:in@[2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if(wd[i].equals("out") &&
				   (i+2 < tlength && tag[i+2].equals("in")))
						tcopy[i] = "rp";
    	tag = tcopy;

		// tag:nnps>nnp <- tag:cc@[-1]&tag:nnp@[-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnps"))
    				if((i-1 >= 0 && tag[i-1].equals("cc")) &&
				   (i-2 >= 0 && tag[i-2].equals("nnp")))
						tcopy[i] = "nnp";
    	tag = tcopy;

		// tag:nn>rb <- wd:to@[0]&wd:close@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if(wd[i].equals("to") &&
				   (i+1 < tlength && wd[i+1].equals("close")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:rbr>rb <- wd:no@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rbr"))
    				if((i-1 >= 0 && wd[i-1].equals("no")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:jj>vbd <- tag:dt@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i+1 < tlength && tag[i+1].equals("dt")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:rb>nnp <- tag:nnp@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("rb"))
    				if((i-1 >= 0 && tag[i-1].equals("nnp")))
						tcopy[i] = "nnp";
    	tag = tcopy;

		// tag:md>nn <- wd:good@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("md"))
    				if((i-1 >= 0 && wd[i-1].equals("good")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:jj>nn <- wd:nn@[0]&tag:giant@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if(wd[i].equals("nn") &&
				   (i-1 >= 0 && tag[i-1].equals("giant")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:nn>jj <- wd:official@[0]&tag:nns@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if(wd[i].equals("official") &&
				   (i+1 < tlength && tag[i+1].equals("nns")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:,@[-1]&tag:prp$@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals(",")) &&
				   (i+1 < tlength && tag[i+1].equals("prp$")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:,@[-1]&tag:rb@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals(",")) &&
				   (i+1 < tlength && tag[i+1].equals("rb")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:nn@[-1]&tag:prp@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("nn")) &&
				   (i+1 < tlength && tag[i+1].equals("prp")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:nnp>jj <- wd:South@[0]&tag:jj@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if(wd[i].equals("South") &&
				   (i+1 < tlength && tag[i+1].equals("jj")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:nn>vbg <- tag:rb@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i-1 >= 0 && tag[i-1].equals("rb")))
						tcopy[i] = "vbg";
    	tag = tcopy;

		// tag:nns>vbz <- tag:,@[-1]&tag:to@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nns"))
    				if((i-1 >= 0 && tag[i-1].equals(",")) &&
				   (i+1 < tlength && tag[i+1].equals("to")))
						tcopy[i] = "vbz";
    	tag = tcopy;

		// tag:vbz>nns <- tag:nn@[-1]&tag:.@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbz"))
    				if((i-1 >= 0 && tag[i-1].equals("nn")) &&
				   (i+1 < tlength && tag[i+1].equals(".")))
						tcopy[i] = "nns";
    	tag = tcopy;

		// tag:nn>vb <- tag:prp$@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nn"))
    				if((i+1 < tlength && tag[i+1].equals("prp$")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:vbp>vb <- wd:do@[-1,-2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbp"))
    				if((i-1 >= 0 && wd[i-1].equals("do")) || (i-2 >= 0 && wd[i-2].equals("do")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:vb>jj <- wd:countries@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vb"))
    				if((i+1 < tlength && wd[i+1].equals("countries")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:in>wdt <- tag:rb@[1]&tag:vbz@[2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if((i+1 < tlength && tag[i+1].equals("rb")) &&
				   (i+2 < tlength && tag[i+2].equals("vbz")))
						tcopy[i] = "wdt";
    	tag = tcopy;

		// tag:jj>vb <- tag:dt@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if((i+1 < tlength && tag[i+1].equals("dt")))
						tcopy[i] = "vb";
    	tag = tcopy;

		// tag:wdt>dt <- tag:vbz@[1]&tag:,@[2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("wdt"))
    				if((i+1 < tlength && tag[i+1].equals("vbz")) &&
				   (i+2 < tlength && tag[i+2].equals(",")))
						tcopy[i] = "dt";
    	tag = tcopy;

		// tag:nnp>rb <- wd:,@[0]&wd:First@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if(wd[i].equals(",") &&
				   (i+1 < tlength && wd[i+1].equals("First")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:dt>nnp <- wd:A@[0]&tag:vbz@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("dt"))
    				if(wd[i].equals("A") &&
				   (i+1 < tlength && tag[i+1].equals("vbz")))
						tcopy[i] = "nnp";
    	tag = tcopy;

		// tag:jj>rbr <- wd:,@[0]&wd:further@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if(wd[i].equals(",") &&
				   (i+1 < tlength && wd[i+1].equals("further")))
						tcopy[i] = "rbr";
    	tag = tcopy;

		// tag:cd>prp <- wd:one@[0]&tag:md@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("cd"))
    				if(wd[i].equals("one") &&
				   (i+1 < tlength && tag[i+1].equals("md")))
						tcopy[i] = "prp";
    	tag = tcopy;

		// tag:pos>'' <- tag:.@[-1,-2,-3]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("pos"))
    				if((i-1 >= 0 && tag[i-1].equals(".")) || (i-2 >= 0 && tag[i-2].equals(".")) || (i-3 >= 0 && tag[i-3].equals(".")))
						tcopy[i] = "''";
    	tag = tcopy;

		// tag:prp>nn <- tag:-LRB-@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("prp"))
    				if((i-1 >= 0 && tag[i-1].equals("-LRB-")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:,@[-1]&tag:prp@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals(",")) &&
				   (i+1 < tlength && tag[i+1].equals("prp")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:nn@[-1]&tag:nns@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("nn")) &&
				   (i+1 < tlength && tag[i+1].equals("nns")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:vbn>vbd <- tag:nn@[-1]&tag:rp@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbn"))
    				if((i-1 >= 0 && tag[i-1].equals("nn")) &&
				   (i+1 < tlength && tag[i+1].equals("rp")))
						tcopy[i] = "vbd";
    	tag = tcopy;

		// tag:nnp>nn <- wd:start@[0]&wd:Business@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if(wd[i].equals("start") &&
				   (i-1 >= 0 && wd[i-1].equals("Business")))
						tcopy[i] = "nn";
    	tag = tcopy;

		// tag:vbd>vbn <- tag:vbg@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("vbd"))
    				if((i-1 >= 0 && tag[i-1].equals("vbg")))
						tcopy[i] = "vbn";
    	tag = tcopy;

		// tag:in>rb <- wd:,@[0]&wd:before@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if(wd[i].equals(",") &&
				   (i+1 < tlength && wd[i+1].equals("before")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:in>rb <- wd:As@[0]&wd:as@[2]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("in"))
    				if(wd[i].equals("As") &&
				   (i+2 < tlength && wd[i+2].equals("as")))
						tcopy[i] = "rb";
    	tag = tcopy;

		// tag:nnp>jj <- wd:New@[0]&wd:York-based@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if(wd[i].equals("New") &&
				   (i-1 >= 0 && wd[i-1].equals("York-based")))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:nnp>jj <- wd:Mexican@[0]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if(wd[i].equals("Mexican"))
						tcopy[i] = "jj";
    	tag = tcopy;

		// tag:nnp>nnps <- wd:Motors@[0]&tag:nnp@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if(wd[i].equals("Motors") &&
				   (i+1 < tlength && tag[i+1].equals("nnp")))
						tcopy[i] = "nnps";
    	tag = tcopy;

		// tag:nnp>nnps <- wd:nnp@[0]&tag:Enterprises@[-1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("nnp"))
    				if(wd[i].equals("nnp") &&
				   (i-1 >= 0 && tag[i-1].equals("Enterprises")))
						tcopy[i] = "nnps";
    	tag = tcopy;

		// tag:jj>rb <- wd:long@[0]&tag:in@[1]

		for(int i=0; i<tlength; i++)
    			if(tag[i].equals("jj"))
    				if(wd[i].equals("long") &&
				   (i+1 < tlength && tag[i+1].equals("in")))
						tcopy[i] = "rb";
    	tag = tcopy;

		return tag;
	}
}
