package openmind;

import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;


public class CreateProfile extends JPanel implements ActionListener{
    JLabel lProfession, lReligion, lRace, lAge, lNickname, lStatus;
    JComboBox cbProfession, cbReligion, cbRace;
    JButton bCreate, bCrawl;
    JTextField tfAge, tfNickname, tfRecommend;
    JTextArea taOutput;
    JPanel pInput, pOutput, pProfession, pReligion, pRace, pAge, pSubmit, pEmpty;
    Connection con;
    JScrollPane spOut;
    String strNickname, strProfession, strReligion, strRace,  strAge;
    FileWriter fwProfileFile;
    StringReader srProfileInfo;
    FileIO fileIO = new FileIO();
    boolean bFlag = false;
	Vector vProf, vRel, vAge, vRace;
	VisAAANet pVisAAANet;
	
	
    public CreateProfile(){
		taOutput = new JTextArea(25, 50);
		taOutput.setLineWrap(true);
		taOutput.setWrapStyleWord(true);
		spOut = new JScrollPane(taOutput);
		spOut.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		pOutput = new JPanel();
		pInput = new JPanel();
		pProfession = new JPanel();
		pReligion = new JPanel();
		pRace = new JPanel();
		pAge = new JPanel();
		pSubmit = new JPanel();
		lStatus = new JLabel();
		
		
		pInput.setBackground(Color.white);
		pOutput.setBackground(Color.white);
		pProfession.setBackground(Color.white);
		pReligion.setBackground(Color.white);
		pRace.setBackground(Color.white);
		pAge.setBackground(Color.white);
		pSubmit.setBackground(Color.white);
		
		bCreate = new JButton("Create from Openmind");
		bCrawl = new JButton("Crawl AAA");
		tfAge = new JTextField();
		tfNickname= new JTextField();
		lNickname = new JLabel("Nickname:");
		lProfession = new JLabel("Profession:");
		lReligion = new JLabel("Religion:");
		lRace = new JLabel("Ethnicity:");
		lAge = new JLabel("Age:");
		lStatus = new JLabel();
		String[] sProfession = {"Engineer", 
					"Doctor", 
					"Athelete",
					"Artist", 
					"Banker",
					"Lawyer",
					"Researcher",
					"Unemployed"};
		String[] sReligion = { "Atheist",
				       "Buddhism",
				       "Catholic",
				       "Muslim",
				       "Protestant"};
		String[] sRace = {"African American",
					"American",
					"Asian",
				    "British",
				    "Indian",
				  	};
					      
		cbProfession = new JComboBox(sProfession);
		cbReligion = new JComboBox(sReligion);
		cbRace = new JComboBox(sRace);
	
		cbProfession.setSelectedIndex(0);
		cbReligion.setSelectedIndex(0);
		cbRace.setSelectedIndex(0);
		
		con = new Connection("http://commonsense.media.mit.edu/cgi-bin/get.cgi?");
		
		bCreate.addActionListener(this);
		bCrawl.addActionListener(this);
	
		pInput.setLayout(new GridLayout(5, 3, 1, 1));
		
		pInput.add(lNickname);
		pInput.add(tfNickname);
		pEmpty = new JPanel();
		pEmpty.setBackground(Color.white);
		pInput.add(pEmpty);
	
		pInput.add(lProfession);
		pInput.add(cbProfession);
		pInput.add(bCreate);
	
		pInput.add(lReligion);
		pInput.add(cbReligion);
		pInput.add(bCrawl);
		
		pInput.add(lRace);
		pInput.add(cbRace);
		pInput.add(lStatus);
	
		pInput.add(lAge);
		pInput.add(tfAge);
		pEmpty = new JPanel();
		pEmpty.setBackground(Color.white);
		pInput.add(pEmpty);
		
		pInput.setBorder(BorderFactory.createCompoundBorder(
								    BorderFactory.createTitledBorder("Personal Facts"),
								    BorderFactory.createEmptyBorder(5,5,5,5)));
		
		pOutput.setLayout(new GridLayout(1, 2, 1, 1));
		
		pVisAAANet = new VisAAANet();
		pOutput.add(pVisAAANet);
	
		pOutput.add(spOut);
		pOutput.setBorder(BorderFactory.createCompoundBorder(
								    BorderFactory.createTitledBorder("Attribute Net"),
								    BorderFactory.createEmptyBorder(5,5,5,5)));
		
		setLayout(new BorderLayout());
		setPreferredSize(new Dimension(100, 100));
		add(pInput, BorderLayout.NORTH);
       	add(pOutput, BorderLayout.CENTER);
    }
    
    public void actionPerformed(ActionEvent ae){
	    strNickname = tfNickname.getText();
	    strProfession = (String) cbProfession.getSelectedItem();
	    strReligion = (String) cbReligion.getSelectedItem();
	    strRace = (String) cbRace.getSelectedItem();
	    strAge = tfAge.getText();
	    if(strAge == null || strAge.equals("")){
			strAge = "22";
    	}
	    Integer age = new Integer(strAge);
	    int iAge = age.intValue();
	    if(iAge < 10){
			strAge = "Child";
	    }
	    else if(iAge < 20){
			strAge = "Teenager";
	    }
	    else if(iAge < 30){
			strAge = "Young";
	    }
	    else if(iAge < 50){
			strAge = "Adult";
	    }
	    else if(iAge < 100){
			strAge = "Elderly";
	    }
	    else {
			strAge = "Adult";
	    }
		if(ae.getSource() == bCreate){
			if(strNickname == null || strNickname.equals("")){
				taOutput.setText("Please enter a nickname for your profile");
    		}
	    	else{
				taOutput.setText("");
			    taOutput.append(strNickname + " " + strProfession +  " " + strReligion + " " + strRace + " " + strAge + "\n");
			    
	    		lStatus.setText("Connecting to OpenMind...");
				//sChosenType = (String)cbInputTypes.getSelectedItem();
				
			/*  New thread here to do the connection call so that it doesn't hang the whole GUI */
				Thread tOutput = new Thread(){
			    public void run(){
					try{
						lStatus.setText("Looking up "+strProfession+" on OpenMind...");
					    String sProfResults = con.getResults(strProfession);
					    taOutput.append("Getting attributes based on profession ... \n");
					    taOutput.append(sProfResults);
					    taOutput.append("Done \n");
					    					    
					    lStatus.setText("Looking up "+strReligion+" on OpenMind...");
					    String sRelResults = con.getResults(strReligion);
					    taOutput.append("Getting attributes based on religion ... \n");
					    taOutput.append(sRelResults);
					    taOutput.append("Done \n");
					    	
					    
					    lStatus.setText("Looking up "+strRace+" on OpenMind...");
					    String sRaceResults = con.getResults(strRace);
					    taOutput.append("Getting attributes based on race ... \n");
					    taOutput.append(sRaceResults);
					    taOutput.append("Done \n");
					    					    
					    lStatus.setText("Looking up "+strAge+" on OpenMind...");
					    String sAgeResults = con.getResults(strAge);
					    taOutput.append("Getting attributes based on age ... \n");
					    taOutput.append(sAgeResults);
					    taOutput.append("Done \n\n");
					    					    
					    lStatus.setText("Writing to: "+strNickname + ".txt");
					    			    
					    Vector vResults = new Vector();
					    vResults.add(sProfResults);
					    vResults.add(sRelResults);
					    vResults.add(sRaceResults);
					    vResults.add(sAgeResults);
					    
					    bFlag = storeProfileFile(strNickname + ".txt", vResults);
					    lStatus.setText("");
					}
					catch(Exception e){
					    taOutput.append(e.toString());
					}
					if(bFlag){
					    taOutput.append("Profile Stored");
					}
					else{
					    taOutput.append("An error has occured");
					}
			    }
			};	    
		    tOutput.start();
		}
	    }
		else if(ae.getSource() == bCrawl){
		    lStatus.setText("Looking up "+strProfession+" on AAANet...");
		    pVisAAANet.omcs.profSyns = fileIO.readFileToVector("attributes/profession/"+strProfession.toLowerCase()+".txt");
			
			lStatus.setText("Looking up "+strReligion+" on AAANet...");
			pVisAAANet.omcs.relSyns = fileIO.readFileToVector("attributes/religion/"+strReligion.toLowerCase()+".txt");
			
			lStatus.setText("Looking up "+strRace+" on AAANet...");
			pVisAAANet.omcs.ageSyns = fileIO.readFileToVector("attributes/race/"+strRace.toLowerCase()+".txt");
			
			lStatus.setText("Looking up "+strAge+" on AAANet...");
			pVisAAANet.omcs.raceSyns = fileIO.readFileToVector("attributes/age/"+strAge.toLowerCase()+".txt");
			
			lStatus.setText("Building custom AAANet...");
			pVisAAANet.omcs.createNet();
			
			lStatus.setText("Populating nodes...");
			pVisAAANet.populateAAANodes();
			
		    lStatus.setText("Done");
		}
	    
    }
    
    public boolean storeProfileFile(String sFilename, Vector vResults){
		boolean bFlag = false;
		String sFile = "";
		try{
			//Filter and sort results
			for (int i=0;i<vResults.size();i++){
			    vResults.set(i, fileIO.sort(fileIO.filterAndCount((String) vResults.get(i))));
			}			    
	
		    //Add headers
		    vResults.set(0, "---Profession---:" + strProfession + "\n" + ((String) vResults.get(0)));
		    vResults.set(1, "---Religion---:" + strReligion + "\n" + ((String) vResults.get(1)));
		    vResults.set(2, "---Race---:" + strRace + "\n" + ((String) vResults.get(2)));
		    vResults.set(3, "---Age---:" + strAge + "\n" + ((String) vResults.get(3)));
			
			//Combine results
			for (int i=0;i<vResults.size();i++){			
	   		   	sFile += vResults.get(i);
		    }
		    
		    //Write the information into a file.
		    fwProfileFile = new FileWriter(sFilename);	
		    srProfileInfo = new StringReader(sFile);
		    int c;
		    while((c = srProfileInfo.read()) != -1){
				fwProfileFile.write(c);
		    }
		    srProfileInfo.close();
		    fwProfileFile.close();
		    bFlag = true;
		}
		catch(Exception e){
		    System.out.println(e.toString());
		}
		return bFlag;
    }
   
}