package openmind;

import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Openmind implements KeyListener {
    private JTextArea in;
    private JTextArea out;
    private Connection con;
    private Tagger tagger = new Tagger();
    
    public Component createComponents() {
	
	out = new JTextArea(80, 80);
	
	in = new JTextArea(80, 80);
	
	JPanel pane = new JPanel();
	pane.setBorder(BorderFactory.createEmptyBorder(10, //top
						       10, //left
						       10, //bottom
						       10) //right
		       );
	pane.setLayout(new GridLayout(1, 0, 10, 10));
	pane.add(in);
	pane.add(out);
	
	in.addKeyListener(this);
	return pane;
    }
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}
    public void keyTyped(KeyEvent e) {
	if (e.getKeyChar() == ' ' || e.getKeyChar() == '\n') {
	    in.append(""+e.getKeyChar());
	    //if (e.getKeyChar() == '\n') {
	    tagger.parse(in.getText());
	    out.append(tagger.nouns());
	    int words = (new StringTokenizer(in.getText())).countTokens();
	    out.setText("");
	    if (words > 0) {
		con = new Connection("http://commonsense.media.mit.edu/cgi-bin/get.cgi?");
		con.setNumberResults(5);
		String nouns = tagger.nouns();
		String results = con.getResults(nouns);
		StringTokenizer st = new StringTokenizer(nouns);
		out.append(results);
	    }
	}
    }
    public static void main(String[] args) {
	try {
	    UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
	} catch (Exception e) {
	}
	
	//Create the top-level container and add contents to it.
	JFrame frame = new JFrame("Openmind");
	frame.setSize(640, 480);

	Openmind app = new Openmind();
	
	//Finish setting up the frame, and show it.
	frame.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    System.exit(0);
		}
	    });
	
	Component contents = app.createComponents();
	frame.getContentPane().add(contents, BorderLayout.CENTER);
	
	frame.pack();
	frame.setVisible(true);
    }
}




