package openmind;

import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Openmind_Timer extends JPanel{
//public class Openmind_Timer implements KeyListener {
    private JTextArea in;
    private JTextArea out;
    private Connection con;
    private Tagger tagger = new Tagger();
    
    java.util.Timer tTimer;
    JPanel pIn, pOut;
    JScrollPane spIn, spOut;

    public Openmind_Timer(){
	
	out = new JTextArea(35, 40);
	out.setLineWrap(true);
	out.setWrapStyleWord(true);
	spOut = new JScrollPane(out);
	spOut.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
	in = new JTextArea(5, 40);
	in.setLineWrap(true);
	in.setWrapStyleWord(true);
	spIn = new JScrollPane(in);
	spIn.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
	pIn = new JPanel();
	pOut = new JPanel();
	
	pIn.setBackground(Color.white);
	pOut.setBackground(Color.white);
	
	pIn.setBorder(BorderFactory.createCompoundBorder(
                              BorderFactory.createTitledBorder("Input"),
                              BorderFactory.createEmptyBorder(5,5,5,5)));

        pOut.setBorder(BorderFactory.createCompoundBorder(
                              BorderFactory.createTitledBorder("Output"),
                              BorderFactory.createEmptyBorder(5,5,5,5)));
	
	//setBorder(BorderFactory.createEmptyBorder(10, //top
	//						       10, //left
	//				       10, //bottom
	//				       10) //right
	//);
	setLayout(new BorderLayout());
	
	//setLayout(new GridLayout(2, 1, 1, 1));
	pIn.add(spIn);
	pOut.add(spOut);
	add(pIn, BorderLayout.NORTH);
	add(pOut, BorderLayout.CENTER);
	//Create a timer for the output panel so that it keeps polling for updates
	/*
	  using a different timer so that it won't hang the program when it is polling. This timer uses the swing api so will crash the gui.  The other one uses just normal java so it just runs in the backgroud. 
	  int delay = 5000;
        ActionListener alPoll = new ActionListener() {
		public void actionPerformed(ActionEvent ae) {
		    //System.out.println(in.getText());
		    tagger.parse(in.getText());
		    out.append(tagger.nouns());
		    int words = (new StringTokenizer(in.getText())).countTokens();
		    out.setText("");
		    if (words > 0) {
			con = new Connection("http://commonsense.media.mit.edu");
			String nouns = tagger.nouns();
			String[] results = con.get(nouns, 5);
			StringTokenizer st = new StringTokenizer(nouns);
			//System.out.println("The nouns are: " + nouns + String.valueOf(st.countTokens()));
			String next = "";
			int i = 0;
			//for (int i = 0; i < st.countTokens(); i++) {
			while(st.hasMoreTokens()){
			    next = st.nextToken();
			    //  System.out.print(String.valueOf(i) + " " + next + " ");
			    out.append("Searched Openmind for "+ next +":\n");
			    out.append(results[i]+"\n");
			    i++;
			}
		    }  
		}		
	    };
	*/
	TimerTask ttPoll = new TimerTask(){
		public void run(){
		    //System.out.println(in.getText());
		    tagger.parse(in.getText());
		    //out.append(tagger.nouns());
		    int words = (new StringTokenizer(in.getText())).countTokens();
		    //out.setText("");
		    if (words > 0) {
			con = new Connection("http://commonsense.media.mit.edu/cgi-bin/get.cgi?");
			con.setNumberResults(5);
			String nouns = tagger.nouns();
			String results = con.getResults(nouns);
			StringTokenizer st = new StringTokenizer(nouns);
			System.out.println("The nouns are: " + nouns + String.valueOf(st.countTokens()));
			String next = "";
			int i = 0;
			//for (int i = 0; i < st.countTokens(); i++) {
			out.setText(results);
		    }  
		}		
	    };
	
	
	tTimer = new java.util.Timer();
	tTimer.schedule(ttPoll, (long) 1000, (long) 5000);
	
	//	tTimer = new javax.swing.Timer(delay, alPoll);
	//tTimer.start();
	//in.addKeyListener(this);
	//	return pane;
    }
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}
    public void keyTyped(KeyEvent e) {
	/*
	if (e.getKeyChar() == ' ' || e.getKeyChar() == '\n') {
	    in.append(""+e.getKeyChar());
	    //if (e.getKeyChar() == '\n') {
	    tagger.parse(in.getText());
	    out.append(tagger.nouns());
	    int words = (new StringTokenizer(in.getText())).countTokens();
	    out.setText("");
	    if (words > 0) {
		con = new Connection("http://commonsense.media.mit.edu");
		String nouns = tagger.nouns();
		String[] results = con.get(nouns, 5);
		StringTokenizer st = new StringTokenizer(nouns);
		for (int i = 0; i < words; i++) {
	            out.append("Searched Openmind for "+st.nextToken()+":\n");
		    out.append(results[i]+"\n");
		}
	    }
	}
	*/
    }
    
    public static void main(String[] args) {
	try {
	    UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
	} catch (Exception e) {
	}
	
	//Create the top-level container and add contents to it.
	JFrame frame = new JFrame("Openmind");
//	frame.setSize(600, 400);
	Openmind_Timer omtPanel = new Openmind_Timer();
	
	//Finish setting up the frame, and show it.
	frame.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    System.exit(0);
		}
	    });
	
	//Component contents = app.createComponents();
	//frame.getContentPane().add(contents, BorderLayout.CENTER);
	frame.getContentPane().add(omtPanel, BorderLayout.CENTER);
	frame.pack();
	frame.setVisible(true);
    }
}













