package openmind;

public class Pair extends Object implements Comparable {
    
    private String strWord;
    private int iVal;
    private double dVal;
    private String strType;
    private AAANode anNode;
    
    public Pair(String sWord, int iValue){
		strWord = sWord;
		iVal = iValue;
		dVal = 0;
		strType = "";
    }
	
	public Pair(String sWord, double dValue){
		strWord = sWord;
		iVal = 0;
		dVal = dValue;
		strType = "";
	}
	
	public Pair(String sWord, double dValue, String type){
		strWord = sWord;
		iVal = 0;
		dVal = dValue;
		strType = type;
	}
	
	public Pair(AAANode node){
		strWord = node.name;
		iVal = 0;
		dVal = node.weight;
		strType = node.type;
		anNode = node;
	}
	
	public Pair(String wordPlusValue){//tab delimited
		String[] s = wordPlusValue.split("\t");
		strWord = s[0];
		iVal = (new Integer(s[1])).intValue();
    }
	
    public String getWord(){
		return strWord;
    }

    public int getValue(){
		return iVal;
    }
    
    public double getDValue(){
    	return dVal;
    }
    
	public String getType(){
		return strType;
	}
	
	public AAANode getNode(){
		return anNode;
	}
    
    //compare to is reversed. so that the most frequent are sorted first
    public int compareTo(Object o){
    	Pair pair = (Pair) o;
    	if(this.iVal<pair.iVal||this.dVal<pair.dVal) return +1;
    	if(this.iVal>pair.iVal||this.dVal>pair.dVal) return -1;
    	return 0;
    }
    
    public String toString(){
    	return "Word: "+strWord+" freq: "+iVal;
    }
}