package openmind;

/**
 * @author Austin
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */

import java.util.*;
import touchgraph.graphlayout.*;
import java.awt.*;

public class Profile {
	private boolean populated = false;
	
	private String[] attributes = new String[4];//prof, rel, race, age
	
	private Vector[] profNodes = new Vector[4];
	private Vector[] relNodes = new Vector[4];
	private Vector[] raceNodes = new Vector[4];
	private Vector[] ageNodes = new Vector[4];
	
	private Vector genreNodes = new Vector();
	private Vector instanceNodes = new Vector();
	private Vector relatedNodes = new Vector();
	
	
	public Profile(String p, String r, String ra, String a){
		attributes[0] = p;
		attributes[1] = r;
		attributes[2] = ra;
		attributes[3] = a;
		
		profNodes[0] = new Vector();//hasWant nodes
		profNodes[1] = new Vector();//vector of other nodes containing node name
		profNodes[2] = new Vector();//vector of colocate of wants
		profNodes[3] = new Vector();//vector of vector of bw isA of other nodes containing node name

		relNodes[0] = new Vector();//hasWant nodes
		relNodes[1] = new Vector();//vector of other nodes containing node name
		relNodes[2] = new Vector();//vector of colocate of wants
		relNodes[3] = new Vector();//vector of vector of bw isA of other nodes containing node name

		raceNodes[0] = new Vector();//hasWant nodes
		raceNodes[1] = new Vector();//vector of other nodes containing node name
		raceNodes[2] = new Vector();//vector of colocate of wants
		raceNodes[3] = new Vector();//vector of vector of bw isA of other nodes containing node name

		ageNodes[0] = new Vector();//hasWant nodes
		ageNodes[1] = new Vector();//vector of other nodes containing node name
		ageNodes[2] = new Vector();//vector of colocate of wants
		ageNodes[3] = new Vector();//vector of vector of bw isA of other nodes containing node name

	}
	
	public void addProfWantNodes(AAANode node){
		profNodes[0].add(node);
		profNodes[3].add(new Vector());
	}
	public void addRelWantNodes(AAANode node){
		relNodes[0].add(node);
		relNodes[3].add(new Vector());
	}
	public void addRaceWantNodes(AAANode node){
		raceNodes[0].add(node);
		raceNodes[3].add(new Vector());
	}
	public void addAgeWantNodes(AAANode node){
		ageNodes[0].add(node);
		ageNodes[3].add(new Vector());
	}
	
	public Vector getProfNodes(int i){
		return profNodes[i];
	}
	public Vector getRelNodes(int i){
		return relNodes[i];
	}
	public Vector getRaceNodes(int i){
		return raceNodes[i];
	}
	public Vector getAgeNodes(int i){
		return ageNodes[i];
	}
	
	public void visualise(VisualNet pVisual){
		//draw attributes
		pVisual.addColouredNode("YOU", attributes[0].toLowerCase(), Color.CYAN, Color.RED, Color.GRAY);
		pVisual.addColouredNode("YOU", attributes[1].toLowerCase(), Color.CYAN, Color.RED, Color.GRAY);
		pVisual.addColouredNode("YOU", attributes[2].toLowerCase(), Color.CYAN, Color.RED, Color.GRAY);
		pVisual.addColouredNode("YOU", attributes[3].toLowerCase(), Color.CYAN, Color.RED, Color.GRAY);
		
		Vector wantNodes = new Vector();
		Vector similarNodeVector = new Vector();
		Vector collocateNodeVector = new Vector();
		Vector isANodeVectorVector = new Vector();
		
		for(int x = 0;x<4;x++){
			//get vectors
			switch (x){
				case 0: wantNodes = profNodes[0];similarNodeVector = profNodes[1];collocateNodeVector = profNodes[2];isANodeVectorVector = profNodes[3];break;
				case 1: wantNodes = relNodes[0];similarNodeVector = relNodes[1];collocateNodeVector = relNodes[2];isANodeVectorVector = relNodes[3];break;
				case 2: wantNodes = raceNodes[0];similarNodeVector = raceNodes[1];collocateNodeVector = raceNodes[2];isANodeVectorVector = raceNodes[3];break;
				case 3: wantNodes = ageNodes[0];similarNodeVector = ageNodes[1];collocateNodeVector = ageNodes[2];isANodeVectorVector = ageNodes[3];break;
			}
			
			//draw	
			for(int i=0;i<wantNodes.size();i++){
				//draw want nodes
				AAANode wantNode = (AAANode) wantNodes.get(i);
				pVisual.addColouredNode(attributes[x].toLowerCase(), wantNode.name.toLowerCase(), Color.RED, Color.BLUE, Color.RED);
				
				//draw similar nodes
				Vector similarNodes = (Vector) similarNodeVector.get(i);
				Vector isANodeVector = (Vector) isANodeVectorVector.get(i);
				for(int j=0;j<similarNodes.size();j++){
					AAANode simNode = (AAANode) similarNodes.get(j);
					pVisual.addColouredNode(wantNode.name.toLowerCase(), simNode.name.toLowerCase(), Color.BLUE, Color.GREEN, Color.BLUE);
					
					//draw isA nodes
					Vector isANodes = (Vector) isANodeVector.get(j);
					for(int k=0;k<isANodes.size();k++){
						AAANode isANode = (AAANode) isANodes.get(k);
						pVisual.addColouredNode(simNode.name.toLowerCase(), isANode.name.toLowerCase(), Color.GREEN, Color.GRAY, Color.GREEN);
					}
				}
				/*
				
				//draw collocate nodes
				Vector collocateNodes = (Vector) collocateNodeVector.get(i);
				for(int j=0;j<collocateNodes.size();j++){
					AAANode colNode = (AAANode) collocateNodes.get(j);
					pVisual.addColouredNode(wantNode.name.toLowerCase(), colNode.name.toLowerCase(), Color.BLUE, Color.GRAY, Color.CYAN);
				}
				*/
			}
		}
	}
	
	public Vector toStringVector(){
		Vector out = new Vector();
		Vector instanceNodes = getInstanceNodes();
		Vector genreNodes = getGenreNodes();
		Vector relatedNodes = getRelatedNodes();
		for(int i=0;i<instanceNodes.size();i++){
			AAANode node = (AAANode) instanceNodes.get(i);
			out.add(node.name);
		}
		for(int i=0;i<genreNodes.size();i++){
			AAANode node = (AAANode) genreNodes.get(i);
			out.add(node.name);
		}
		for(int i=0;i<relatedNodes.size();i++){
			AAANode node = (AAANode) relatedNodes.get(i);
			out.add(node.name);
		}
		return out;
	}
	
	public Vector toVector(){
		Vector out = new Vector();
		Vector instanceNodes = getInstanceNodes();
		Vector genreNodes = getGenreNodes();
		Vector relatedNodes = getRelatedNodes();
		for(int i=0;i<instanceNodes.size();i++){
			AAANode node = (AAANode) instanceNodes.get(i);
			out.add(node);
		}
		for(int i=0;i<genreNodes.size();i++){
			AAANode node = (AAANode) genreNodes.get(i);
			out.add(node);
		}
		for(int i=0;i<relatedNodes.size();i++){
			AAANode node = (AAANode) relatedNodes.get(i);
			out.add(node);
		}
		return out;
	}

	
	public Vector toInstanceStringVector(){
		Vector instanceNodes = getInstanceNodes();
		Vector out = new Vector();
		for(int i=0;i<instanceNodes.size();i++){
			AAANode node = (AAANode) instanceNodes.get(i);
			out.add(node.name);
		}
		return out;
	}

	public Vector getInstanceNodes(){
		if(!populated) populateVectors();
		return (Vector) instanceNodes.clone();
	}
	
	public Vector getGenreNodes(){
		if(!populated) populateVectors();
		return (Vector) genreNodes.clone();
	}
	
	public Vector getRelatedNodes(){
		if(!populated) populateVectors();
		return (Vector) relatedNodes.clone();
	}
	
	public void populateVectors(){
		if(!populated){
			genreNodes = new Vector();
			instanceNodes = new Vector();
			relatedNodes = new Vector();
			
			genreNodes.addAll(profNodes[0]);
			Vector temp = profNodes[1];
			for(int i=0;i<temp.size();i++){
				relatedNodes.addAll((Vector) temp.get(i));
			}
			temp = profNodes[2];
			for(int i=0;i<temp.size();i++){
				relatedNodes.addAll((Vector) temp.get(i));
			}
			temp = profNodes[3];
			for(int i=0;i<temp.size();i++){
				Vector temp2 = (Vector) temp.get(i);
				for(int j=0;j<temp2.size();j++){
					instanceNodes.addAll((Vector) temp2.get(j));
				}
			}
			
			genreNodes.addAll(relNodes[0]);
			temp = relNodes[1];
			for(int i=0;i<temp.size();i++){
				relatedNodes.addAll((Vector) temp.get(i));
			}
			temp = relNodes[2];
			for(int i=0;i<temp.size();i++){
				relatedNodes.addAll((Vector) temp.get(i));
			}
			temp = relNodes[3];
			for(int i=0;i<temp.size();i++){
				Vector temp2 = (Vector) temp.get(i);
				for(int j=0;j<temp2.size();j++){
					instanceNodes.addAll((Vector) temp2.get(j));
				}
			}
			
			genreNodes.addAll(raceNodes[0]);
			temp = raceNodes[1];
			for(int i=0;i<temp.size();i++){
				relatedNodes.addAll((Vector) temp.get(i));
			}
			temp = raceNodes[2];
			for(int i=0;i<temp.size();i++){
				relatedNodes.addAll((Vector) temp.get(i));
			}
			temp = raceNodes[3];
			for(int i=0;i<temp.size();i++){
				Vector temp2 = (Vector) temp.get(i);
				for(int j=0;j<temp2.size();j++){
					instanceNodes.addAll((Vector) temp2.get(j));
				}
			}
			
			genreNodes.addAll(ageNodes[0]);
			temp = ageNodes[1];
			for(int i=0;i<temp.size();i++){
				relatedNodes.addAll((Vector) temp.get(i));
			}
			temp = ageNodes[2];
			for(int i=0;i<temp.size();i++){
				relatedNodes.addAll((Vector) temp.get(i));
			}
			temp = ageNodes[3];
			for(int i=0;i<temp.size();i++){
				Vector temp2 = (Vector) temp.get(i);
				for(int j=0;j<temp2.size();j++){
					instanceNodes.addAll((Vector) temp2.get(j));
				}
			}
		}
		populated = true;
	}
	
	public String toString(){
		String out = "";
		Vector nodes = toVector();
		Pair[] pairs = new Pair[nodes.size()];
		for(int i=0;i<nodes.size();i++){
			AAANode node = (AAANode) nodes.get(i);
			Pair p = new Pair(node.name, node.weight, node.type);
			pairs[i] = p;
		}
		Arrays.sort(pairs);
		for(int i=0;i<pairs.length;i++){
			Pair node = pairs[i];
			out += node.getType() + ": " + node.getWord() + " " + node.getDValue() + "\n";			
		}
		/*
		for(int i=0; i<4;i++){
			out += "Profession:";
			out += profNodes[i].toString() + "\n";
			out += "Religion:";
			out += relNodes[i].toString() + "\n";
			out += "Race:";
			out += raceNodes[i].toString() + "\n";
			out += "Age:";
			out += ageNodes[i].toString() + "\n";
		}
		*/
		return out;
	}
}
