package openmind;

import java.util.*;


class Tagger {
	private Lexicon lexicon;
	private Guesser guesser;
	private ContextRules contextrules;
	private static String[] wd;
	private static String[] tag;
	private static int words;
public Tagger() {

		// Plug in the lexicon
		lexicon = new Lexicon();

		// Plug in the guesser
		guesser = new Guesser();

		// Plug in the context rules
		contextrules = new ContextRules();
	}
/**
 * Insert the method's description here.
 * Creation date: (9/13/2002 3:59:46 PM)
 * @param args java.lang.String[]
 */
public static void main(String[] args) {
    Tagger t = new Tagger();
    t.parse("Hello. I went to the supermarket and saw my mother.");
    for (int i = 0; i < words; i++) {
        System.out.println(wd[i] + tag[i]);
    }
    System.out.println("nouns: "+t.nouns());
    System.out.println("verbs: "+t.verbs());
}
/**
 * Insert the method's description here.
 * Creation date: (9/13/2002 3:56:08 PM)
 * @return java.lang.String
 */
public String nouns() {
    String nouns = "";
    for (int i = 0; i < words; i++) {
        if (tag[i] == "nn") {
            nouns += wd[i]+" ";
        }
    }
    return nouns;
}
public void parse(String input) {

    // Tokenize the input
    StringTokenizer st = new StringTokenizer(input);

    // Determine the length of the input
    words = st.countTokens();

    // Allocate two arrays of that length
    wd = new String[words];
    tag = new String[words];

    // Fill them with words and parts of speech
    for (int i = 0; i < words; i++) {
        wd[i] = st.nextToken();
        tag[i] = lexicon.lookup(wd[i]);
        if (tag[i].equals("$unknown")) {
            // Call the guesser with different default tag
            // depending on the capitalization of the word
            if (Character.isUpperCase(wd[i].charAt(0)))
                tag[i] = guesser.guess("nnp", wd[i]);
            else
                tag[i] = guesser.guess("nn", wd[i]);
        }
    }

    // Apply the rules
    String[] tag1 = contextrules.apply(tag, wd);
    

}
/**
 * Insert the method's description here.
 * Creation date: (9/13/2002 3:56:22 PM)
 * @return java.lang.String
 */
public String verbs() {
    String verbs = "";
    for (int i = 0; i < words; i++) {
        if (tag[i] == "vbd") {
            verbs += wd[i]+" ";
        }
    }
    return verbs;
}
}
