package openmind;
import java.net.*;
import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class ViewNet extends JPanel implements ActionListener{
    JLabel lRelation, lType, lTerm, lExpand;
    JComboBox cbRelation, cbType;
    JButton bCreate;
    JTextField tfExpand, tfTerm;
    JTextArea taOutput;
    JPanel pInput, pOutput, pRelation, pType, pTerm, pExpand, pSubmit, pEmpty;
    JScrollPane spOut;
    String strConnection, strQuery, strType, strRelation, strExpand, strTerm;


    public ViewNet(){
	taOutput = new JTextArea(33, 40);
	taOutput.setLineWrap(true);
	taOutput.setWrapStyleWord(true);
	spOut = new JScrollPane(taOutput);
	spOut.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
	pOutput = new JPanel();
	pInput = new JPanel();
	pRelation = new JPanel();
	pType = new JPanel();
	pTerm = new JPanel();
	pExpand = new JPanel();
	pSubmit = new JPanel();

	
	pInput.setBackground(Color.white);
	pOutput.setBackground(Color.white);
	pRelation.setBackground(Color.white);
	pType.setBackground(Color.white);
	pTerm.setBackground(Color.white);
	pExpand.setBackground(Color.white);
	pSubmit.setBackground(Color.white);
	
	bCreate = new JButton("Query");
	tfExpand = new JTextField();
	tfTerm = new JTextField();
	lRelation = new JLabel("Relation:");
	lType = new JLabel("Type:");
	lTerm = new JLabel("Term:");
	lExpand = new JLabel("Expand:");
	String[] sRelation = {"cityinstate",
			      "hasAbility",
			      "hasCollocate",
			      "hasEffect",
			      "hasFirststep",
			      "hasLocation",
			      "hasMotivation",
			      "hasParenttype",
			      "hasPart",
			      "hasRequirement",
			      "hasResultingwant",
			      "hasStep",
			      "hasUnwant",
			      "hasUse",
			      "hasUseLocation",
			      "hasWant"};

	String[] sType = {"synonyms",
			  "term",
			  "source",
			  "target"};
					      
	cbRelation = new JComboBox(sRelation);
	cbType = new JComboBox(sType);
	//cbRace = new JComboBox(sRace);

	cbRelation.setSelectedIndex(0);
	cbType.setSelectedIndex(0);
	//cbRace.setSelectedIndex(0);
	
	//cbRelation.addActionListener(this);
	//cbReligion.addActionListener(this);
	//cbRace.addActionListener(this);

	bCreate.addActionListener(this);

	pInput.setLayout(new GridLayout(5, 3, 1, 1));
	//pInput.setLayout(new GridLayout(5, 3, 1, 1));
	//pInput.add(pRelation);
	//pInput.add(pReligion);
	//pInput.add(pRace);
	//pInput.add(pAge);
	pInput.add(lRelation);
	pInput.add(cbRelation);
	pEmpty = new JPanel();
	pEmpty.setBackground(Color.white);
	pInput.add(pEmpty);
	

	pInput.add(lType);
	pInput.add(cbType);
	pEmpty = new JPanel();
	pEmpty.setBackground(Color.white);

	pInput.add(pEmpty);
	pInput.add(lTerm);
	pInput.add(tfTerm);
	pEmpty = new JPanel();
	pEmpty.setBackground(Color.white);

	pInput.add(pEmpty);
	pInput.add(lExpand);
	pInput.add(tfExpand);
	pEmpty = new JPanel();
	pEmpty.setBackground(Color.white);
	pInput.add(pEmpty);

	pEmpty = new JPanel();
	pEmpty.setBackground(Color.white);
	pInput.add(pEmpty);
	pInput.add(bCreate);
	pInput.setBorder(BorderFactory.createCompoundBorder(
							    BorderFactory.createTitledBorder("Query Parameters"),
							    BorderFactory.createEmptyBorder(5,5,5,5)));

	pOutput.add(spOut);
	pOutput.setBorder(BorderFactory.createCompoundBorder(
							    BorderFactory.createTitledBorder("OMCSNET Says"),
							    BorderFactory.createEmptyBorder(5,5,5,5)));
	
	setLayout(new BorderLayout());
	setPreferredSize(new Dimension(100, 100));
	add(pInput, BorderLayout.NORTH);
       	add(pOutput, BorderLayout.CENTER);
    }
    
    public void actionPerformed(ActionEvent ae){
	
	if(ae.getSource() == bCreate){
	    strType = (String) cbType.getSelectedItem();
	    strRelation = (String) cbRelation.getSelectedItem();
	    strExpand = tfExpand.getText();
	    strTerm = tfTerm.getText();
	    try{
	    strTerm = URLEncoder.encode(strTerm,"UTF-8");
	    }
	    catch (Exception e){}
	    strConnection = "http://taffy.media.mit.edu/cgi-bin/omcsnet-get.cgi?";
	    strQuery = "";

	    taOutput.setText("");
	    taOutput.append(strType +  " " + strRelation + " " + strExpand + " " + strTerm + "\n\n");

	    if(strTerm == null || strTerm.equals("")){
		//Don't do anything
	    }
	    else{
		if(strType.equals("synonyms")){
		    strQuery = "synonyms=" + strTerm;
		}
		else if(strType.equals("term")){
		    strQuery = "term=" + strTerm;
		}
		else if(strType.equals("target")){
		    strQuery = "target=" + strTerm + 
			"&relation=" + strRelation;
		    if(strExpand == null || strExpand.equals("")){
			//Do nothing
		    }
		    else{
			strQuery += "&expand=" + strExpand;
		    }
		}
		else if(strType.equals("source")){
		    strQuery = "source=" + strTerm + 
			"&relation=" + strRelation;
		    if(strExpand == null || strExpand.equals("")){
			//Do nothing
		    }
		    else{
			strQuery += "&expand=" + strExpand;
		    }
		}

		else{
		    //just chill
		}
	    }
	    taOutput.append(strQuery);
	    Thread tOutput = new Thread(){
		    public void run(){
			try{
			    taOutput.append(strConnection + strQuery);
			    URL url = new URL(strConnection + strQuery);
			    URLConnection uc = url.openConnection();
			    StringBuffer buffer = new StringBuffer();
			    InputStreamReader in = new InputStreamReader(uc.getInputStream(), "UTF-8");
			    int chr = in.read();
			    String sReturnValue = "";
			    
			    while (chr != -1){
				buffer.append((char) chr);
				chr = in.read();
			    }
			    in.close();
			    sReturnValue = buffer.toString();
			    taOutput.append(sReturnValue);
			}	
			catch(Exception e){
			    taOutput.append(e.toString());
			}
		    }
		};
	    tOutput.start();
	}
	
	
    }
}





