package openmind;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import touchgraph.graphlayout.*;

/**
 * Austin created VisAmazon at 6:57:33 PM on Nov 16, 2002
 */
public class VisAmazon extends JPanel implements ActionListener{
	VisualNet pVisual;
	JPanel pInput;
	JButton bCreate, bClear;
	JTextField tfKeyword;
	JLabel lKeyword, lMode;
	JComboBox cbMode;
    String[] aRelations;
	String strKeyword, strMode;
    JCheckBox[] cbRelations;
	Vector vRelations;
	Amazon aAmazon;
	
	public VisAmazon(){
		//pInput
		pInput = new JPanel();
		bCreate = new JButton("Find");
		bCreate.addActionListener(this);
		bClear = new JButton("Clear");
		bClear.addActionListener(this);
		
		lKeyword = new JLabel("Keyword: ", SwingConstants.RIGHT);
		tfKeyword = new JTextField();
		
		lMode = new JLabel("Mode: ", SwingConstants.RIGHT);
		String[] sMode = {"Books","Music","DVD"};
		cbMode = new JComboBox(sMode);
		
		pInput.setBackground(Color.white);
		pInput.setBorder(BorderFactory.createCompoundBorder(
								    BorderFactory.createTitledBorder("Query Amazon"),
								    BorderFactory.createEmptyBorder(5,5,5,5)));
		pInput.setLayout(new GridLayout(1, 6, 1, 1));
		pInput.add(lKeyword);
		pInput.add(tfKeyword);
		pInput.add(lMode);
		pInput.add(cbMode);
		JPanel pEmpty = new JPanel();
		pEmpty.setBackground(Color.white);
		pInput.add(pEmpty);
		pInput.add(bCreate);
		pInput.add(bClear);
		
		//pVisual
		pVisual = new VisualNet(); //extends JPanel
		pVisual.changeDefaultLength(100);	    	
		pVisual.setBorder(BorderFactory.createCompoundBorder(
							     BorderFactory.createTitledBorder("Amazon Visualisation"),
							     BorderFactory.createEmptyBorder(5,5,5,5)));
		
		setLayout(new BorderLayout());
		add(pInput, BorderLayout.NORTH);
		add(pVisual, BorderLayout.CENTER);
		
		//Amazon
		aAmazon = new Amazon();
		
	}


  	public void actionPerformed(ActionEvent ae){
		if(ae.getSource() == bCreate){
			strKeyword = tfKeyword.getText();
	    	strMode = (String) cbMode.getSelectedItem();
	    	
			Thread tOutput = new Thread(){
				public void run(){
					Vector vResults = aAmazon.searchAmazon(strKeyword,strMode.toLowerCase());
					for(int i=0;i<vResults.size();i++){
						AAANode anNode = (AAANode) vResults.get(i);
						String parent = anNode.name;
						for(int j=0;j<anNode.edges.size();j++){
							pVisual.addColouredNode(parent, ((Edge) anNode.edges.get(j)).Pred, Color.red, Color.GRAY);
						}		
					}
				}		
		   	};
		tOutput.start();
	    }
	    else if(ae.getSource() == bClear){
	    	pVisual.clearAll();
	    }
  	}
}
