package openmind;
import java.net.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import touchgraph.graphlayout.*;

public class VisNet extends JPanel implements ActionListener{
    JLabel lRelation, lType, lTerm, lExpand, lLevels, lLength;
    JComboBox cbRelation, cbType;
    JButton bCreate;
    JTextField tfExpand, tfTerm, tfLevels, tfLength;
    JPanel pInput, pRelation, pType, pTerm, pExpand, pSubmit, pEmpty, pLevels, pLength;
    VisualNet pVisual;
    JScrollPane spOut;
    String strConnection, strQuery, strType, strRelation, strExpand, strTerm, sReturnValue;
	int intLevels, intLength;
	Color[] colours;

    public VisNet(){
	pVisual = new VisualNet(); //extends JPanel
	pInput = new JPanel();
	pRelation = new JPanel();
	pType = new JPanel();
	pTerm = new JPanel();
	pExpand = new JPanel();
	pLevels = new JPanel();
	pLength = new JPanel();
	pSubmit = new JPanel();
	
	
	pInput.setBackground(Color.white);
	pRelation.setBackground(Color.white);
	pType.setBackground(Color.white);
	pTerm.setBackground(Color.white);
	pExpand.setBackground(Color.white);
	pLevels.setBackground(Color.white);
	pLength.setBackground(Color.white);
	pSubmit.setBackground(Color.white);
	
	bCreate = new JButton("Query");
	tfExpand = new JTextField();
	tfTerm = new JTextField();
	tfLevels = new JTextField("1");
	tfLength = new JTextField("100");
	lRelation = new JLabel("Relation: ", SwingConstants.RIGHT);
	lType = new JLabel("Type: ", SwingConstants.RIGHT);
	lTerm = new JLabel("Term: ", SwingConstants.RIGHT);
	lExpand = new JLabel("Expand: ", SwingConstants.RIGHT);
	lLevels = new JLabel("Levels to expand: ", SwingConstants.RIGHT);
	lLength = new JLabel("Length of arcs: ", SwingConstants.RIGHT);
	String[] sRelation = {"cityinstate",
			      "hasAbility",
			      "hasCollocate",
			      "hasEffect",
			      "hasFirststep",
			      "hasLocation",
			      "hasMotivation",
			      "hasParenttype",
			      "hasPart",
			      "hasRequirement",
			      "hasResultingwant",
			      "hasStep",
			      "hasUnwant",
			      "hasUse",
			      "hasUseLocation",
			      "hasWant"};
	
	String[] sType = {"synonyms",
			  "term",
			  "source",
			  "target"};
	
	cbRelation = new JComboBox(sRelation);
	cbType = new JComboBox(sType);
	
	cbRelation.setSelectedIndex(0);
	cbType.setSelectedIndex(0);
	
	bCreate.addActionListener(this);
	
	pInput.setLayout(new GridLayout(4, 4, 1, 1));
	
	pInput.add(lRelation);
	pInput.add(cbRelation);
	
	pInput.add(lType);
	pInput.add(cbType);
	
	pInput.add(lTerm);
	pInput.add(tfTerm);
	
	pInput.add(lExpand);
	pInput.add(tfExpand);
	
	pInput.add(lLevels);
	pInput.add(tfLevels);
	
	pInput.add(lLength);
	pInput.add(tfLength);
	
	/*		pEmpty = new JPanel();
			pEmpty.setBackground(Color.white);
			pInput.add(pEmpty);
	*/	
	pEmpty = new JPanel();
	pEmpty.setBackground(Color.white);
	pInput.add(pEmpty);
	pInput.add(bCreate);
	pInput.setBorder(BorderFactory.createCompoundBorder(
							    BorderFactory.createTitledBorder("Query Parameters"),
							    BorderFactory.createEmptyBorder(5,5,5,5)));
	
	//pVisual.add(spOut);
	pVisual.setBorder(BorderFactory.createCompoundBorder(
							     BorderFactory.createTitledBorder("AAA Visualisation"),
							     BorderFactory.createEmptyBorder(5,5,5,5)));
	
	setLayout(new BorderLayout());
	setPreferredSize(new Dimension(100, 100));
	add(pInput, BorderLayout.NORTH);
	
	
	add(pVisual, BorderLayout.CENTER);
    }
    
    public void actionPerformed(ActionEvent ae){
	if(ae.getSource() == bCreate){
	    strType = (String) cbType.getSelectedItem();
	    strRelation = (String) cbRelation.getSelectedItem();
	    strExpand = tfExpand.getText();
	    try{intLevels = (new Integer(tfLevels.getText())).intValue();}
	    catch (Exception e){intLevels = 1;}
	    try{intLength = (new Integer(tfLength.getText())).intValue();}
	    catch (Exception e){intLength = 100;}
	    strTerm = tfTerm.getText();
	}
	Thread tOutput = new Thread(){
		public void run(){
		    pVisual.changeDefaultLength(intLength);
		    colours = new Color[intLevels];
		    Random r = new Random();
		    for(int i=0;i<intLevels;i++){
				colours[i] = new Color(r.nextInt(255),r.nextInt(255),r.nextInt(255));
		    }
		    expand(strTerm, intLevels);
		}
	    };
	tOutput.start();
    }
    
    public String getResults(String node){
	strConnection = "http://taffy.media.mit.edu/cgi-bin/omcsnet-get.cgi?";
	strQuery = "";
	String tempTerm = "";
	try{tempTerm = URLEncoder.encode(node,"UTF-8");}
	catch (Exception e){}
	
	if(tempTerm == null || tempTerm.equals("")){
	    //Don't do anything
	}
	else{
	    if(strType.equals("synonyms")){
		strQuery = "synonyms=" + tempTerm;
	    }
	    else if(strType.equals("term")){
		strQuery = "term=" + tempTerm;
	    }
	    else if(strType.equals("target")){
		strQuery = "target=" + tempTerm + 
		    "&relation=" + strRelation;
		if(strExpand == null || strExpand.equals("")){
		    //Do nothing
		}
		else{
		    strQuery += "&expand=" + strExpand;
		}
	    }
	    else if(strType.equals("source")){
		strQuery = "source=" + tempTerm + 
		    "&relation=" + strRelation;
		if(strExpand == null || strExpand.equals("")){
		    //Do nothing
		}
		else{
		    strQuery += "&expand=" + strExpand;
		}
	    }	
	    else{
		//just chill
	    }
	}
	try{
	    //taOutput.append(strConnection + strQuery);
	    URL url = new URL(strConnection + strQuery);
	    URLConnection uc = url.openConnection();
	    StringBuffer buffer = new StringBuffer();
	    InputStreamReader in = new InputStreamReader(uc.getInputStream(), "UTF-8");
	    int chr = in.read();
	    sReturnValue = "";
	    
	    while (chr != -1){
		buffer.append((char) chr);
		chr = in.read();
	    }
	    in.close();
	    sReturnValue = buffer.toString();
	}
	catch(Exception e){
	    //taOutput.append(e.toString());
	    System.out.println("exception: "+e);
	}
	return sReturnValue;		
    }
    
    public void expand (String parent, int levels){
    	if (levels>0) {
		    String results = getResults(parent);
		    int resultType = 0;
		    try{
				StringTokenizer st = new StringTokenizer(results,"\n");
				while(st.hasMoreTokens()){
				    String child = st.nextToken();
				    try{    		
						if(child.equals("--- SYNONYM RESULTS ---")) {
						    child = st.nextToken();
						    resultType = 1;
						}
						else if(child.equals("--- TERM EXPANSION RESULTS ---")) {
						    child = st.nextToken();
						    resultType = 2;
						}
						else if(child.equals("--- TARGET RESULTS ---")) {
						    child = st.nextToken();
						    resultType = 3;
						}
						else if(child.equals("--- SOURCE RESULTS ---")) {
						    child = st.nextToken();
						    resultType = 4;
						}
				    }
				    catch (Exception e){}
				    if(!child.equals("--- END OF RESULTS ---")&&resultType!=0) {
						//System.out.println("parent: "+parent+", child: "+child+", colour: "+colours[levels-1]);
						addNode(parent, child, resultType, colours[levels-1]);
						expand(child, levels-1);
				    }
				}
		    }
		    catch (Exception e){}	
		}   
    }
    
    public void addNode(String parent, String child, int resultType, Color colour){
		switch(resultType){
			case 1: pVisual.addSynonymNode(parent, child, colour);break;
			case 2: pVisual.addTermNode(parent, child, colour);break;
			case 3: pVisual.addTargetNode(parent, child, colour);break;
			case 4: pVisual.addSourceNode(parent, child, colour);break;
		}				
    }
}

	
    













